// ImportCSV.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "birthday.h"
#include "ImportCSV.h"
#include "SVreader.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CImportCSV 


CImportCSV::CImportCSV(CWnd* pParent /*=NULL*/)
	: CDialog(CImportCSV::IDD, pParent)
{
	//{{AFX_DATA_INIT(CImportCSV)
	//}}AFX_DATA_INIT
}


void CImportCSV::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImportCSV)
	DDX_Control(pDX, IDC_CHECK_USENODATES, m_check_usenodates);
	DDX_Control(pDX, IDC_FILENAME, m_edit_filename);
	DDX_Control(pDX, IDC_EDIT_EVENT, m_edit_event);
	DDX_Control(pDX, IDC_COMBO_USE_NAME_3, m_combo_use_name_3);
	DDX_Control(pDX, IDC_COMBO_USE_NAME_2, m_combo_use_name_2);
	DDX_Control(pDX, IDC_COMBO_USE_NAME_1, m_combo_use_name_1);
	DDX_Control(pDX, IDC_COMBO_USE_EVENT, m_combo_use_event);
	DDX_Control(pDX, IDC_COMBO_USE_DATE, m_combo_use_data);
	DDX_Control(pDX, IDC_COMBO_DATEFORMAT, m_combo_dateformat);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CImportCSV, CDialog)
	//{{AFX_MSG_MAP(CImportCSV)
	ON_CBN_EDITCHANGE(IDC_COMBO_USE_DATE, OnEditchangeComboUseDate)
	ON_CBN_SELCHANGE(IDC_COMBO_USE_DATE, OnSelchangeComboUseDate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CImportCSV 

BOOL CImportCSV::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_edit_filename.SetWindowText( strFilename);

	csvReader.straArray.Copy( straFile);
	csvReader.Prepare();
	csvReader.ParseFirstLine();

	m_combo_use_name_2.AddString( "[none]");
	m_combo_use_name_3.AddString( "[none]");
	m_combo_use_event.AddString( "[none]");
	if( csvReader.lstLine.GetCount() > 0)
	{
		CString strOut;
		POSITION pPos;
		pPos = csvReader.lstLine.GetHeadPosition();
		do
		{
			strOut = csvReader.lstLine.GetNext( pPos);
			m_combo_use_name_1.AddString( strOut);
			m_combo_use_name_2.AddString( strOut);
			m_combo_use_name_3.AddString( strOut);
			m_combo_use_event.AddString( strOut);
			m_combo_use_data.AddString( strOut);
		}
		while( pPos != NULL);

	}
	m_combo_use_name_1.SetCurSel(0);
	m_combo_use_name_2.SetCurSel(0);
	m_combo_use_name_3.SetCurSel(0);
	m_combo_use_event.SetCurSel(2);
	m_combo_use_data.SetCurSel(3);


	//selections...
	if( m_combo_use_name_1.SelectString( -1, "Anrede") == CB_ERR)//german
	{
		if( m_combo_use_name_1.SelectString( -1, "Title") == CB_ERR)//english
		{
			m_combo_use_name_1.SelectString( -1, "Name");
		}
		else
		{
			m_combo_use_name_2.SelectString( -1, "First Name");//english
			m_combo_use_name_3.SelectString( -1, "Last Name");//english
		}
	}
	else
	{
		m_combo_use_name_2.SelectString( -1, "Vorname");//german
		m_combo_use_name_3.SelectString( -1, "Nachname");//german
	}

	if( m_combo_use_event.SelectString( -1, "Event") == CB_ERR)
	{
		m_combo_use_event.SelectString( -1, "[none]");
		m_edit_event.SetWindowText( "birthday");
	}

	if( m_combo_use_data.SelectString( -1, "Geburtstag") == CB_ERR)//german
	{
		if( m_combo_use_data.SelectString( -1, "Birthday") == CB_ERR)//english outlook
			m_combo_use_data.SelectString( -1, "Date");
	}
	//get the right date format
	CImportCSV::OnSelchangeComboUseDate();

	return TRUE;
}//BOOL CImportCSV::OnInitDialog() 



void CImportCSV::OnOK() 
{
	nUseDate	= m_combo_use_data.GetCurSel();//has no [none]
	m_combo_dateformat.GetLBText( m_combo_dateformat.GetCurSel(), strDateformat);

	nUseEvent	= m_combo_use_event.GetCurSel() - 1;
	if( nUseEvent == -1)//use self-typed event only if there is [none] selected
		m_edit_event.GetWindowText( strUseEvent);
	else
		strUseEvent = "";

	nUseName1	= m_combo_use_name_1.GetCurSel();//has no [none]
	nUseName2	= m_combo_use_name_2.GetCurSel() - 1;
	nUseName3	= m_combo_use_name_3.GetCurSel() - 1;

	if( m_check_usenodates.GetCheck() == 0)
		bUseNoDates = false;
	else
		bUseNoDates = true;


	CDialog::OnOK();
}//void CImportCSV::OnOK() 

void CImportCSV::OnEditchangeComboUseDate() 
{
}

void CImportCSV::OnSelchangeComboUseDate() 
{
	int nCmbDatePos = m_combo_use_data.GetCurSel();

	if( csvReader.straArray.GetSize() > 0)
	{

		char chDateSeparator;
		int nA,nB, nDateSep1, nDateSep2;
		//1 - month, 2 - day, 3 - year
		int nDate1, nDate2, nDate3;
		CString strDate, strDate1, strDate2, strDate3, strDateType;
		POSITION pPos;

		csvReader.Prepare();
		csvReader.nFilePos = -1;//that we not need differ between FirstLine and NextLine
		nA = 0;
		nDate1 = 1;
		nDate2 = 1;
		nDate3 = 1;
		while( nA < csvReader.straArray.GetSize() && nA < 200)
		{

			nA++;
			csvReader.ParseNextLine();
			nB = -1;
			do//find current col
			{

				nB++; 
				if( nB == 0)
					pPos = csvReader.lstLine.GetHeadPosition();
				else	
					csvReader.lstLine.GetNext( pPos);

			}
			while( nB < nCmbDatePos);
			strDate = csvReader.lstLine.GetAt( pPos);
			//find separator
			strDate.Replace( "0", "");
			strDate.Replace( "1", "");
			strDate.Replace( "2", "");
			strDate.Replace( "3", "");
			strDate.Replace( "4", "");
			strDate.Replace( "5", "");
			strDate.Replace( "6", "");
			strDate.Replace( "7", "");
			strDate.Replace( "8", "");
			strDate.Replace( "9", "");
			chDateSeparator = strDate.GetAt(0);
			strDate = csvReader.lstLine.GetAt( pPos);

			nDateSep1 = strDate.Find( chDateSeparator);
			if( nDateSep1 != -1)
			{
				nDateSep2 = strDate.Find( chDateSeparator, nDateSep1 + 1);
				if( nDateSep2 != -1)
				{

					strDate1 = strDate.Left( nDateSep1);
					strDate2 = strDate.Mid( nDateSep1 + 1, nDateSep2 - nDateSep1 - 1);
					strDate3 = strDate.Right( strDate.GetLength() - nDateSep2 - 1);
					if( !(atoi( strDate1) == 0 && atoi( strDate2) == 0) && !(atoi( strDate2) == 0 && atoi( strDate3) == 0) && !(atoi( strDate1) == 0 && atoi( strDate3) == 0))
					{
						//could be day?
						if( atoi( strDate1) > 12 && nDate1 < 2)
							nDate1 = 2;
						//could be year?
						if( (atoi( strDate1) > 31 || atoi( strDate1) == 0 || strDate1 == "????") && nDate1 < 3)
							nDate1 = 3;

						//could be day?
						if( atoi( strDate2) > 12 && nDate2 < 2)
							nDate2 = 2;
						//could be year?
						if( (atoi( strDate2) > 31 || atoi( strDate2) == 0 || strDate2 == "????") && nDate2 < 3)
							nDate2 = 3;

						//could be day?
						if( atoi( strDate3) > 12 && nDate3 < 2)
							nDate3 = 2;
						//could be year?
						if( (atoi( strDate3) > 31 || atoi( strDate3) == 0 || strDate3 == "????") && nDate3 < 3)
							nDate3 = 3;
					}//not more than one 0

				}//nDateSep2 != -1
			}//nDateSep1 != -1
		}//while nA < getsize

		if( nDate1 == 1)
			strDate1 = "MM";
		else if( nDate1 == 2)
			strDate1 = "DD";
		else 
			strDate1 = "YYYY";

		if( nDate2 == 1)
			strDate2 = "MM";
		else if( nDate2 == 2)
			strDate2 = "DD";
		else 
			strDate2 = "YYYY";

		if( nDate3 == 1)
			strDate3 = "MM";
		else if( nDate3 == 2)
			strDate3 = "DD";
		else 
			strDate3 = "YYYY";

		//clear the field
		m_combo_dateformat.ResetContent();
		//3 unique types?
		if( strDate1 != strDate2 && strDate1 != strDate3 && strDate2 != strDate3)
		{
			m_combo_dateformat.AddString( strDate1 + chDateSeparator + strDate2 + chDateSeparator + strDate3);
			m_combo_dateformat.SetCurSel(0);
		}
		else//something double!
		{
			bool bMulti = false;

			//1 and 2 are currently month, could be day, too
			if( nDate1 == nDate2 && nDate1 == 1)
			{
				bMulti = true;
				strDate.Format( "DD%cMM%cYYYY", chDateSeparator, chDateSeparator);
				m_combo_dateformat.AddString( strDate);
				strDate.Format( "MM%cDD%cYYYY", chDateSeparator, chDateSeparator);
				m_combo_dateformat.AddString( strDate);
				if( chDateSeparator == '.')//with dots, it should be european date format
					m_combo_dateformat.SetCurSel( 0);
				else
					m_combo_dateformat.SetCurSel( 1);
			}
			//2 and 3 are currently month, could be day, too
			if( nDate2 == nDate3 && nDate2 == 1)
			{
				bMulti = true;
				strDate.Format( "YYYY%cMM%cDD", chDateSeparator, chDateSeparator);
				m_combo_dateformat.AddString( strDate);
				strDate.Format( "YYYY%cDD%cMM", chDateSeparator, chDateSeparator);
				m_combo_dateformat.AddString( strDate);
				//don't know who should use YYYY-DD-MM?
				//write a mail to birthday@cweiske.de if you know such a country
				m_combo_dateformat.SetCurSel( 0);
			}
			//1 and 3 are currently month, could be day, too
			if( nDate1 == nDate3 && nDate1 == 1)
			{
				bMulti = true;
				strDate.Format( "DD%cYYYY%cMM", chDateSeparator, chDateSeparator);
				m_combo_dateformat.AddString( strDate);
				strDate.Format( "MM%cYYYY%cDD", chDateSeparator, chDateSeparator);
				m_combo_dateformat.AddString( strDate);
				//don't know if there is a date format like this.
				//write a mail to birthday@cweiske.de if you know where
				m_combo_dateformat.SetCurSel( 0);
			}
			
			if( bMulti)
			{
				strDate.LoadString( IDS_MSG_MULTIPLEDATEFORMATS);
				MessageBox( strDate, MSGBOXTITLE, 0 + MB_ICONINFORMATION);
			}

		}

		if( chDateSeparator != '.' && chDateSeparator != '/' && chDateSeparator != '-')
		{
			strDate.LoadString( IDS_MSG_ITHINKNODATE);
			MessageBox( strDate, MSGBOXTITLE, 0 + MB_ICONINFORMATION);
		}

	}//linecount > 0


}//onChangeUseDate
