// CSVreader by Christian Weiske, cweiske@cweiske.de
// SVreader.cpp: Implementierung der Klasse CSVreader.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "stdafx.h"
#include "SVreader.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CSVreader::CSVreader()
{
	nFilePos = 0;
}

CSVreader::~CSVreader()
{

}


//Parse one DATA line (can be several text lines)
bool CSVreader::ParseLine( int nArPos)
{
	lstLine.RemoveAll();
		
	strLine = straArray.GetAt( nArPos);//get first text line of data
	nLineLength = strLine.GetLength();

	nError = 0;//not too much
	nError2 = 0;//not too much
	nA = 0;//begin
	nB = 0;//end
	nC = 0;//quoteplace
	nD = 0;//find 2
	bTodo = true;
	bTodo2 = true;
	bListEnd = false;
	nMaxLoops = 1000;

	do
	{
		nError++;
		//strLine = straArray.GetAt( nArPos);
		if( strLine.GetAt( nA) != '\"')//no quotes, no problem
		{
			nB = strLine.Find( chSeparator, nA);
			if( nB == -1)
			{
				nB = nLineLength;
				bTodo = false;
			}
			strPart = strLine.Mid( nA, nB - nA);
			nA = nB + 1;
		}
		else//quotes begin here
		{

			strSmallPart = "";//own string, cause can be of several parts
			nC = nA + 1;
			bTodo2 = true;
			do
			{
				nError2++;
				nD = strLine.Find( "\"", nC);//find quote
				if( nD == -1)//newline
				{
					strSmallPart += strLine.Mid( nC, strLine.GetLength() - nC);
					nC = 0;
					nArPos++;
					if( nArPos >= straArray.GetSize())
						bListEnd = true;
					else
						strLine = straArray.GetAt( nArPos);
				}
				else//end quote? or double-quote?
				{
					//check if not above string length and if quote
					if( nD + 1 < strLine.GetLength() && strLine.Mid( nD + 1, 1) == "\"")//double quote
					{
						strSmallPart += strLine.Mid( nC, nD - nC + 1);//get text with one quote
						if( nD + 2 >= strLine.GetLength())//double-qotes at line end?
						{
							nC = 0;
							nArPos++;
							if( nArPos >= straArray.GetSize())
								bListEnd = true;
							else
								strLine = straArray.GetAt( nArPos);
						}
						else//no!
						{
							nC = nD + 2;//move forward, overjump the 2 quotes
						}
					}
					else//end quote
					{
						strSmallPart += strLine.Mid( nC, nD - nC);
						bTodo2 = false;
					}//if double
				}//eq/dq?
			}
			while( bTodo2 && nError2 < nMaxLoops && !bListEnd);
			strPart = strSmallPart;
			nA = nD + 2;
			if( nA >= strLine.GetLength())//out of line? done!
			{
				bTodo = false;
			}
		}//with quotes
		lstLine.AddTail( strPart);
	}
	while( bTodo && nError < nMaxLoops && nError2 < nMaxLoops && !bListEnd);

	nFilePos = nArPos;

	if( nError >= nMaxLoops)
	{
		return false;
	}
	if( nError2 >= nMaxLoops)
	{
		return false;
	}

/*	if( lstLine.GetCount() > 0)
	{
		CString strOut, strNum;
		POSITION pPos;
		pPos = lstLine.GetHeadPosition();
		nA = 0;
		do
		{
			nA++;
			strNum.Format( "%d", nA);
			strOut += strNum + ":" + lstLine.GetNext( pPos) + "\n";
		}
		while( pPos != NULL);

		MessageBox( 0, strOut, "CSV test", 0);
	}*/


	return true;
}//bool CSVreader::ParseLine( int nArPos)


bool CSVreader::ParseNextLine()
{
	nFilePos++;
	if( nFilePos >= straArray.GetSize())
		return false;

	return ParseLine( nFilePos);
}//bool CSVreader::ParseNextLine()


void CSVreader::Reset()
{
	nFilePos = 0;
}//void CSVreader::Reset()

char CSVreader::GetSeparator(int nLine)
{
	CString strSepLine;
	strSepLine	= straArray.GetAt( nLine);
	nCountCommas	= strSepLine.Replace( ",", ",");
	nCountSemicolon	= strSepLine.Replace( ";", ";");
	nCountTabs		= strSepLine.Replace( "\t", "\t");

	if( nCountCommas > nCountSemicolon && nCountCommas > nCountTabs)
		return ',';
	else if( nCountSemicolon > nCountCommas && nCountSemicolon > nCountTabs)
		return ';';
	else
		return '\t';
}

bool CSVreader::Prepare()
{
	if( straArray.GetSize() == 0)
		return false;
	chSeparator = GetSeparator(0);
	Reset();

	return true;
}

bool CSVreader::ParseFirstLine()
{
	nFilePos = 0;
	return ParseLine( nFilePos);
}
