// birthday.cpp : Legt das Klassenverhalten fr die Anwendung fest.
//


#include "stdafx.h"
#include "birthday.h"
#include "birthdayDlg.h"
#include "ImportCSV.h"
#include "SVreader.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBirthdayApp

BEGIN_MESSAGE_MAP(CBirthdayApp, CWinApp)
	//{{AFX_MSG_MAP(CBirthdayApp)
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBirthdayApp Konstruktion

CBirthdayApp::CBirthdayApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CBirthdayApp-Objekt

CBirthdayApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CBirthdayApp Initialisierung

BOOL CBirthdayApp::InitInstance()
{
	//for drag n drop
	::CoInitialize( NULL);
	
	setlocale( LC_ALL, "");
	//::SetThreadLocale(MAKELCID(MAKELANGID(LANG_ENGLISH,SUBLANG_DEFAULT),SORT_DEFAULT));

	AfxEnableControlContainer();

	// Standardinitialisierung

#ifdef _AFXDLL
	Enable3dControls();			// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
#else
	Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
#endif

	CBirthdayDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}

	// Da das Dialogfeld geschlossen wurde, FALSE zurckliefern, so dass wir die
	//  Anwendung verlassen, anstatt das Nachrichtensystem der Anwendung zu starten.
	return FALSE;
}

int CBirthdayApp::ExitInstance() 
{
	// for CDropEdit!!
	::CoUninitialize();
	
	return CWinApp::ExitInstance();
}




/////////////////////////////////////////////////////////////////////////////
// Birthday-Parser

void BdayFile::StartParsing(BdayFile *ActBirthFile, bool Add)
{
	CStdioFile BirthdayFile;
	CFileException e;
	if(!BirthdayFile.Open(FileName, CFile::modeRead | CFile::typeText, &e))
	{
		CString ErrText;
		ErrText.LoadString(IDS_PARSE_FILEOPEN_ERROR_TEXT);

		MessageBox(0, ErrText + "\n" + FileName, MSGBOXTITLE, 0 + MB_ICONSTOP );
		FileName = FileNameOld;
		return;
	}
	CString BirthdayContent, strInput;

    while (BirthdayFile.ReadString(strInput))
       BirthdayContent = BirthdayContent + strInput;

	BirthdayFile.Close();
	ActBirthFile->strXSLFile = "http://xml.cweiske.de/files/bdf/1/bdf.xsl";
	Parse(BirthdayContent, ActBirthFile, Add);
}

void BdayFile::Parse(CString Content, BdayFile *ActBirthFile, bool Add)
{
	if(!Add)
		ClearData();
	RealError = false;
	FileEnd = false;
	ErrorPos = "";
	LastPos = 0;

	DWORD ActPos = 0;
	ActBirthFile->Length = Content.GetLength();
	CString ActItem, ActType;

	ActBirthFile->Content = Content;
	if(!Add)
		ActBirthFile->CountPersons = -1;

	do
	{
		ActItem = GetNextItem(ActPos, &Content);
		//get xsl...here we see that it is a shit parser
		if( ActItem == "xml-stylesheet")
		{
			DWORD nPos = Content.Find( "href=\"", ActPos + 1);
			if( nPos != -1)
			{
				CString strXSL = Content.Mid( nPos + 6, Content.Find( "\"", nPos + 6) - nPos - 6);
				if( strXSL.GetLength() > 5) //min. *.xsl -> 5 characters
					ActBirthFile->strXSLFile = strXSL;
			}

		}
		ActType = GetItemType(ActPos, &Content);
		ActPos = GetNewPos(ActPos, &Content);

		if(ActItem == "birthdayfile" && ActType != "/")
		{
			do
			{
				ActItem = GetNextItem(ActPos, &Content);
				ActType = GetItemType(ActPos, &Content);
				ActPos = GetNewPos(ActPos, &Content);
				if(ActItem == "" || ActPos >= ActBirthFile->Length)
				{ FileEnd = true; break;}

				if(ActItem == "version" && ActType != "/")
				{
					ActBirthFile->Version = ConvertFromXML( &GetContent(ActPos, &Content, &ActItem) );

					if(atof(ActBirthFile->FileVersion) > 1)
					{
						Loader.LoadString(IDS_MSG_WRONGVERSION);
						MessageBox( *theApp.GetMainWnd(), Loader, "Warnung", MB_ICONEXCLAMATION);
					}
				}
				if(ActItem == "fileversion" && ActType != "/")
					ActBirthFile->FileVersion = ConvertFromXML( &GetContent(ActPos, &Content, &ActItem) );
				if(ActItem == "author" && ActType != "/")
					ActBirthFile->Author = ConvertFromXML( &GetContent(ActPos, &Content, &ActItem) );
				if(ActItem == "title" && ActType != "/")
					ActBirthFile->Title = ConvertFromXML( &GetContent(ActPos, &Content, &ActItem) );
				if(ActItem == "generator" && ActType != "/")
					ActBirthFile->Generator = ConvertFromXML( &GetContent(ActPos, &Content, &ActItem) );

//content
				if(ActItem == "content" && ActType != "/")
				{
					do
					{
						ActItem = GetNextItem(ActPos, &Content);
						ActType = GetItemType(ActPos, &Content);
						ActPos = GetNewPos(ActPos, &Content);
						if(ActItem == "" || ActPos >= ActBirthFile->Length)
						{ FileEnd = true; break;}
	//persons
							if(ActItem == "person" && ActType != "/")
							{
								if(ActBirthFile->CountPersons+1 < MAXBIRTHDAYS)
								{
									ActBirthFile->CountPersons++;
									do
									{
										ActItem = GetNextItem(ActPos, &Content);
										ActType = GetItemType(ActPos, &Content);
										ActPos = GetNewPos(ActPos, &Content);
										if(ActItem == "" || ActPos >= ActBirthFile->Length)
										{ FileEnd = true; break;}
										if(ActItem == "name" && ActType != "/")
											ActBirthPersons[ActBirthFile->CountPersons].Name = ConvertFromXML( &GetContent(ActPos, &Content, &ActItem) );
										if(ActItem == "date" && ActType != "/")
											ActBirthFile->StringToTime( &ActBirthPersons[ActBirthFile->CountPersons], &GetContent(ActPos, &Content, &ActItem), &RealError, &ErrorPos);
										if(ActItem == "event" && ActType != "/")
											ActBirthPersons[ActBirthFile->CountPersons].Event = ConvertFromXML( &GetContent(ActPos, &Content, &ActItem) );


										if( RealError || FileEnd) 
											break;
									}
									while( !(ActItem == "person" && ActType == "/"));
								}
								else
								{
									Loader.LoadString(IDS_PARSE_ERROR_TOOMUCH);
									MessageBox(0,Loader,MSGBOXTITLE,MB_ICONERROR);
									break;
								}
							}
	//end persons
							if( RealError || FileEnd) 
								break;
					}
					while( !(ActItem == "content" && ActType == "/"));
				}
//settings
				else if(ActItem == "settings" && ActType != "/")
				{
					do
					{
						ActItem = GetNextItem(ActPos, &Content);
						ActType = GetItemType(ActPos, &Content);
						ActPos = GetNewPos(ActPos, &Content);
						if(ActItem == "" || ActPos >= ActBirthFile->Length)
						{ FileEnd = true; break;}

							if(ActItem == "shownext" && ActType != "/")
							{
								int Temp= atoi(GetContent(ActPos, &Content, &ActItem));
								if(Temp > -1 && Temp < 366)
									ShowNext = Temp;
							}
							else if(ActItem == "showlast" && ActType != "/")
							{
								int Temp = atoi(GetContent(ActPos, &Content, &ActItem));
								if(Temp > -1 && Temp < 366)
									ShowLast = Temp;
							}
							else if(ActItem == "alwaysontop" && ActType != "/")
							{
								int Temp = atoi(GetContent(ActPos, &Content, &ActItem));
								if(Temp == 0)
								{
									OnTop = false;
								}
								else if(Temp == 1)
								{
									OnTop = true;
								}
							}
							else if(ActItem == "magnetborder" && ActType != "/")
							{
								int Temp = atoi(GetContent(ActPos, &Content, &ActItem));
								if(Temp == 0)
								{
									MagnetOn = false;
								}
								else if(Temp == 1)
								{
									MagnetOn = true;
								}
							}
					}
					while( !(ActItem == "settings" && ActType == "/"));
				}
//end settings
				if( RealError || FileEnd)
					break;
			}
			while( !(ActItem == "birthdayfile" && ActType == "/") );
		}
		if( RealError || FileEnd)
			break;
	}
 	while(ActPos < ActBirthFile->Length && ActItem != "" && RealError == false && FileEnd == false);

	if(RealError)
	{
		Loader.LoadString(IDS_PARSE_PARSING_ERROR);
		MessageBox(0, Loader + "\n\nPosition:\t" + ErrorPos, MSGBOXTITLE, 0 + MB_ICONSTOP);
		return;
	}

	CalcTimeDiff();
}

						 

CString BdayFile::GetNextItem(DWORD Pos, CString *Content) //get next item string
{
	DWORD posStart = Content->Find("<",Pos) + 1;
	if(Content->Mid(posStart,1) == "/" || Content->Mid(posStart,1) == "?")
		posStart += 1;
	DWORD posEnd = Content->Find(">", posStart+1);
	DWORD posEnd2 = Content->Find(" ", posStart+1);
	if(posEnd2 < posEnd && posEnd2 != -1)
		posEnd = posEnd2;

	if( posEnd == -1 || posStart == -1)
	{
		FileEnd = true;
		return "";
	}

	Pos = posEnd + 1;
CString back = Content->Mid(posStart, posEnd - posStart);
	return back;
}

DWORD BdayFile::GetNewPos(DWORD Pos, CString *Content) //calculate new position
{
	DWORD posStart = Content->Find("<",Pos) + 1;
	DWORD posEnd = Content->Find(">", posStart+1);

	if( posEnd == -1 || posStart == -1 || posEnd < LastPos || posStart < LastPos)
	{
		FileEnd = true;
		return 0;
	}
	LastPos = posEnd + 1;
	return LastPos;
}

CString BdayFile::GetItemType(DWORD Pos, CString *Content) //Get item type; useful for "/" or "?"
{
	DWORD posStart = Content->Find( "<",Pos) + 1;
	DWORD posEnd = Content->Find( ">", posStart + 1);

	if( posEnd == -1 || posStart == -1)
	{
		FileEnd = true;
		return "";
	}
	
	if(Content->Mid(posEnd - 1, 1) == "/")
		return "/";

	return Content->Mid(posStart,1);
}

CString BdayFile::GetContent(DWORD Pos, CString *Content, CString *Item) //Get text between ">" and "</"
{
	DWORD End = Content->Find("</" + *Item, Pos);

	if( End == -1)
	{
		FileEnd = true;
		return "";
	}

	return Content->Mid(Pos, End - Pos);
}


void BdayFile::StringToTime(BdayPerson *Person, CString *Content, bool *RealError = false, LPTSTR *ErrorPos = NULL)
{
	int YearLen, Pos, OldPos = Content->Find(".",0);

	Pos = OldPos;
	Person->Date.day = atoi(Content->Left(Pos));
	if(Pos == 1)
	{
		Content->Insert(0,"0");
		Pos++;
		OldPos++;
	}

	Pos = Content->Find(".",Pos + 1);
	Person->Date.month = atoi(Content->Mid(OldPos + 1, Pos));
	if(Pos == 4)
	{
		Content->Insert(3,"0");
		Pos++;
	}

	Person->Date.year = Content->Mid(Pos + 1);
	YearLen = Content->GetLength() - Pos - 1;

	if( Content->Right(1) == "?")
	{
		if( Content->Right(2) == "??")
		{
			if( Content->Right(3) == "???")
			{
				if( Content->Right(4) != "????")
					*Content = *Content + "?";
			}
			else
				*Content = *Content + "??";
		}
		else
			*Content = *Content + "???";
		YearLen = 4;
	}

	if(YearLen < 4)
	{
		if( YearLen == 1)
		{
				Person->Date.year = 1900 + atoi(Person->Date.year);
				Content->Insert(6,"000");
		}
		if( YearLen == 2)
		{
			Person->Date.year = 1900 + atoi(Person->Date.year);
			Content->Insert(6,"00");
		}
		if( YearLen == 3)
		{
			Person->Date.year = 1000 + atoi(Person->Date.year);
			Content->Insert(6,"0");
		}
	}

	if(Person->Date.month <= 0 || Person->Date.month > 12 || Person->Date.day <= 0 || Person->Date.day > 31)
	{
		*ErrorPos = "StringToTime";
		*RealError = true;
		return;
	}
	Person->Date.DateAsString = *Content;

}


void BdayFile::CalcTimeDiff()
{
	CTime Today, Dummy;
	CTimeSpan TimeDiff;
	
	Today = CTime::GetCurrentTime();

	CString buffer;
	int ybigger, ysmaller;

	for(int a=0; a <= CountPersons; a++)
	{
		//TimeDiff
		int an = Today.GetMonth();

		if( ActBirthPersons[a].Date.month < Today.GetMonth() || (ActBirthPersons[a].Date.month == Today.GetMonth() && ActBirthPersons[a].Date.day < Today.GetDay() ) )
		{
			ybigger = 1;
			ysmaller = 0;
		}
		else
		{
			ybigger = 0;
			ysmaller = 1;
		}

		ActBirthPersons[a].yeardiff = Today.GetYear() - atoi(ActBirthPersons[a].Date.year) + ybigger;
		if( ActBirthPersons[a].Date.year.Right(1) == "?")
			ActBirthPersons[a].yeardiff = 1;

		//Next year
		CTime Dummy (Today.GetYear() + ybigger, ActBirthPersons[a].Date.month, ActBirthPersons[a].Date.day, 0, 0, 0);
		ActBirthPersons[a].strNextWeekday	= Dummy.Format( "%a");

		TimeDiff = Dummy - Today;
		ActBirthPersons[a].daydiffnext = TimeDiff.GetDays() + 1;
		if(ActBirthPersons[a].daydiffnext == 1 && Today.GetDay() == ActBirthPersons[a].Date.day)
			ActBirthPersons[a].daydiffnext = 0;

		//Last year
		CTime Dummy2 (Today.GetYear() - ysmaller, ActBirthPersons[a].Date.month, ActBirthPersons[a].Date.day, 0, 0, 0);
		ActBirthPersons[a].strLastWeekday	= Dummy2.Format( "%a");

		TimeDiff = Today - Dummy2;
		ActBirthPersons[a].daydifflast = TimeDiff.GetDays();
		if(ActBirthPersons[a].daydifflast == 1 && Today.GetDay() == ActBirthPersons[a].Date.day)
			ActBirthPersons[a].daydifflast = 0;


		// Replacing Events
		if(ActBirthPersons[a].Event == "")
			ActBirthPersons[a].Event = "Birthday";
		ConvertFromXML(&ActBirthPersons[a].Name);
	}
}//CalcTimeDiff()

void BdayFile::CalcTimeDiffOne( int a)
{
	CTime Today;
	CTimeSpan TimeDiff;
	
	Today = CTime::GetCurrentTime();

	CString buffer;
	int ybigger, ysmaller;

	//TimeDiff
	int an = Today.GetMonth();

	if( ActBirthPersons[a].Date.month < Today.GetMonth() || (ActBirthPersons[a].Date.month == Today.GetMonth() && ActBirthPersons[a].Date.day < Today.GetDay() ) )
	{
		ybigger = 1;
		ysmaller = 0;
	}
	else
	{
		ybigger = 0;
		ysmaller = 1;
	}

	ActBirthPersons[a].yeardiff = Today.GetYear() - atoi(ActBirthPersons[a].Date.year) + ybigger;
	if( ActBirthPersons[a].Date.year.Right(1) == "?")
		ActBirthPersons[a].yeardiff = 1;

	//Next year
	CTime Dummy (Today.GetYear() + ybigger, ActBirthPersons[a].Date.month, ActBirthPersons[a].Date.day, 0, 0, 0);
	ActBirthPersons[a].strNextWeekday	= Dummy.Format( "%a");

	TimeDiff = Dummy - Today;
	ActBirthPersons[a].daydiffnext = TimeDiff.GetDays() + 1;
	if(ActBirthPersons[a].daydiffnext == 1 && Today.GetDay() == ActBirthPersons[a].Date.day) {
		ActBirthPersons[a].daydiffnext = 0;
	}

	//Last year
	CTime Dummy2 (Today.GetYear() - ysmaller, ActBirthPersons[a].Date.month, ActBirthPersons[a].Date.day, 0, 0, 0);
	ActBirthPersons[a].strLastWeekday	= Dummy2.Format( "%a");

	TimeDiff = Today - Dummy2;
	ActBirthPersons[a].daydifflast = TimeDiff.GetDays();
	if(ActBirthPersons[a].daydifflast == 1 && Today.GetDay() == ActBirthPersons[a].Date.day) {
		ActBirthPersons[a].daydifflast = 0;
	}


	// Replacing Events
	if(ActBirthPersons[a].Event == "") {
		ActBirthPersons[a].Event = "Birthday";
	}
	ConvertFromXML(&ActBirthPersons[a].Name);
}//CalcTimeDiffOne( int a)




CString BdayFile::ConvertFromXML(CString *Content)
{
	Content->Replace("&amp;", "&");
	Content->Replace("&lt;", "<");
	Content->Replace("&gt;", ">");
	Content->Replace("&quot;", "\"");
	Content->Replace("&apos;", "'");
	return *Content;
}

CString BdayFile::ConvertToXML(CString *Content)
{
	CString NewContent = *Content;
	NewContent.Replace("&", "&amp;");
	NewContent.Replace("<", "&lt;");
	NewContent.Replace(">", "&gt;");
	NewContent.Replace("\"", "&quot;");
	NewContent.Replace("'", "&apos;");
	return NewContent;
}

void BdayFile::ConvertEventsFromXML(CString *Content)
{

}

void BdayFile::CreateContent(bool OnlyChecked, LPCTSTR Type, LPCTSTR FileName)
{
	SortItems();

	if(Type == "rdbirthdayfile")
	{
		Content = "<?xml version=\"1.0\" encoding=\"iso-8859-1\" ?>\n";
		Content += "<!DOCTYPE birthdayfile SYSTEM \"http://xml.cweiske.de/files/bdf/1/bdf.dtd\">\n";
		Content += "<?xml-stylesheet type=\"text/xsl\" href=\"" + strXSLFile + "\" ?>\n";

		Content = Content + "<birthdayfile>\n";
		Content = Content + " <version>" + ConvertToXML( &Version) + "</version>\n";
		Content = Content + " <fileversion>" + ConvertToXML( &FileVersion) + "</fileversion>\n";
		Content = Content + " <author>" + ConvertToXML( &Author) + "</author>\n";
		Content = Content + " <title>" + ConvertToXML( &Title) + "</title>\n";
		Content = Content + " <generator>RealDreams Birthday Reminder</generator>\n";

		Content = Content + " <settings>\n";
			Loader.Format("%d", ShowLast);
		Content = Content + "  <showlast>" + Loader + "</showlast>\n";
			Loader.Format("%d", ShowNext);
		Content = Content + "  <shownext>" + Loader + "</shownext>\n";
		Content = Content + " </settings>\n";

		Content = Content + " <content>\n";
		for(int a=0; a <= CountPersons; a++)
		{
			if( (ActBirthPersons[a].Checked && OnlyChecked) || !OnlyChecked)
			{
				Content = Content + "  <person>\n";
					Content = Content + "   <name>" + ConvertToXML( &ActBirthPersons[a].Name) + "</name>\n";
					Content = Content + "   <event>" + ConvertToXML( &ActBirthPersons[a].Event) + "</event>\n";
					Content = Content + "   <date>" + ConvertToXML( &ActBirthPersons[a].Date.DateAsString) + "</date>\n";
				Content = Content + "  </person>\n";
			}
		}
		
		Content = Content + " </content>\n";
		Content = Content + "</birthdayfile>\n";
	}//rdbirthdayfile
	else if( Type == "html")
	{
		Content  = "<html>\n <head>\n  <title>" + ConvertToXML( &Title) +"</title>\n";
		Content += "  <meta name=\"author\" content=\"" + ConvertToXML( &Author) + "\"/>\n  <meta name=\"generator\" content=\"RealDreams birthday reminder\"/>\n </head>\n";
		Content += "<style type=\"text/css\">\n  body { font-family:VERDANA,ARIAL,HELVETICA; font-size:11pt;}\n  table { border:1px solid #000000; border-collapse:collapse;}\n  table th { background-color:#C0C0C0; }\n  table td { padding-left:5px; padding-right:5px; background-color:#FFFFFF; border-bottom:1px dotted #DCDCDC; }\n  table td.date{ text-align:center; }\n  table.fileinformation td, th { padding-left:5px; padding-right:5px; border-bottom:1px solid #000000; }\n  a { text-decoration:none; }\n </style>\n";
		Content += " <body text=\"#000000\" bgcolor=\"#FFFFFF\" link=\"#0000FF\" alink=\"#0000FF\" vlink=\"#0000FF\">\n";
		Content += "  <div style=\"text-align:center\">\n";
		Content += "   <table style=\"border:none;\">\n    <tr>\n     <td style=\"text-align:center; border:none;\">\n";
		Content += "  <table width=\"100%\">\n   <tr>\n";
			Loader.LoadString(IDS_LIST_HEADER_NAME);
		Content += "    <th>" + Loader + "</th>\n";
			Loader.LoadString(IDS_LIST_HEADER_EVENT);
		Content += "    <th>" + Loader + "</th>\n";
			Loader.LoadString(IDS_LIST_HEADER_DATE);
		Content += "    <th>" + Loader + "</th>\n";
		Content += "   </tr>\n";

		for(int a=0; a <= CountPersons; a++)
		{
			if( (ActBirthPersons[a].Checked && OnlyChecked) || !OnlyChecked)
			{
				Content += "<tr>\n";
				Content += " <td>" + ConvertToXML( &ActBirthPersons[a].Name) + "</td>\n";
				Content += " <td>" + ConvertToXML( &ActBirthPersons[a].Event) + "</td>\n";
				Content += " <td class=\"date\">" + ConvertToXML( &ActBirthPersons[a].Date.DateAsString) + "</td>\n";
				Content += "</tr>\n";
			}
		}

		Content += "  </table>\n  <br/>\n";
		Content += "  <table class=\"fileinformation\" width=\"100%\">\n   <tr>\n    <th colspan=\"4\">File information</th>\n   </tr>\n";
		Content += "   <tr><th>Title</th><td colspan=\"3\">" + ConvertToXML( &Title) + "</td></tr>\n";
		Content += "   <tr>\n    <th>Author</th><td>" + ConvertToXML( &Author) + "</td>\n";
		Content += "    <th style=\"border-left:1px solid #000000;\">Version</th>\n    <td>" + ConvertToXML( &Version) + "</td>\n";
		Content += "   </tr>\n  </table>\n  <br/>\n  <table width=\"100%\">\n   <tr>\n";
		Content += "    <td style=\"text-align:center;\">written by Christian Weiske<br/>get birthday reminder at <a href=\"http://www.cweiske.de\">www.cweiske.de</a></td>\n";
		Content += "   </tr>\n  </table>\n     </td>\n    </tr>\n   </table>\n  </div>\n </body>\n</html>";

	}//html
	else if( Type == "csv")
	{
		CString Loader, strSeperator;
		Loader.LoadString( IDS_MSG_SELECT_CSV_SEPERATOR);
		int nAnt = MessageBox( *theApp.GetMainWnd(), Loader, MSGBOXTITLE, MB_OKCANCEL + MB_ICONQUESTION);
		if( nAnt == IDOK)
			strSeperator = ",";
		else
			strSeperator = ";";

		Content  = "\"Name\"" + strSeperator + "\"Event\"" + strSeperator + "\"Date\"\n";

		CString strName = "";
		CString strEvent = "";
		CString strDate = "";
		for(int a=0; a <= CountPersons; a++)
		{
			if( (ActBirthPersons[a].Checked && OnlyChecked) || !OnlyChecked)
			{
				strName = ActBirthPersons[a].Name;
				strName.Replace( "\"", "\"\"");
				strEvent = ActBirthPersons[a].Event;
				strEvent.Replace( "\"", "\"\"");
				strDate = ActBirthPersons[a].Date.DateAsString;
				strDate.Replace( "\"", "\"\"");
				Content += "\"" + strName + "\"" + strSeperator + "\"" + strEvent + "\"" + strSeperator + "\"" + strDate + "\"\n";
			}
		}

	}//csv

}

void BdayFile::ClearData()
{
	for(int a=0; a <= CountPersons; a++)
	{
		ActBirthPersons[a].Date.DateAsString = "";
		ActBirthPersons[a].Date.day = 0;
		ActBirthPersons[a].Date.month = 0;
		ActBirthPersons[a].Date.year = "0";
		ActBirthPersons[a].daydifflast = 0;
		ActBirthPersons[a].daydiffnext = 0;
		ActBirthPersons[a].Event = "";
		ActBirthPersons[a].Name = "";
		ActBirthPersons[a].yeardiff = 0;
	}
}


void BdayFile::InitVariables() //call when starting program
{
	for(int a=0; a < MAXBIRTHDAYS; a++)
	{
		ActBirthPersons[a].Date.DateAsString = "";
		ActBirthPersons[a].Date.day = 0;
		ActBirthPersons[a].Date.month = 0;
		ActBirthPersons[a].Date.year = "0";
		ActBirthPersons[a].daydifflast = 0;
		ActBirthPersons[a].daydiffnext = 0;
		ActBirthPersons[a].Event = "";
		ActBirthPersons[a].Name = "";
		ActBirthPersons[a].yeardiff = 0;
	}
	Author = "";
	Content = "";
	CountPersons = -1;
	ErrorPos = "";
	FileEnd = false;
	FileName = "";
	Generator = "";
	LastPos = -1;
	Length = 0;
	Loader = "";
	MagnetOn = false;
	OnTop = false;
	RealError = false;
	ShowLast = 10;
	ShowNext = 30;
	Title = "";
	Version = "";
	FileVersion = "1";



}

void BdayFile::SortItems()
{
	BdayPerson TempPerson;
	int Lowest;
	bool Changed;

	for(int a = 0; a < CountPersons; a++)
	{
		Lowest = a;
		Changed = false;
		for(int b = a+1; b <= CountPersons; b++)
		{
			if( (ActBirthPersons[b].Date.month < ActBirthPersons[Lowest].Date.month) ||  (ActBirthPersons[b].Date.month == ActBirthPersons[Lowest].Date.month && ActBirthPersons[b].Date.day < ActBirthPersons[Lowest].Date.day) ||  (ActBirthPersons[b].Date.month == ActBirthPersons[Lowest].Date.month && ActBirthPersons[b].Date.day == ActBirthPersons[Lowest].Date.day && atoi(ActBirthPersons[b].Date.year) > atoi(ActBirthPersons[Lowest].Date.year)  ) )
			{
				Lowest = b;
				Changed = true;
			}//if new Lowest
		}//for b
		if(Changed)
		{
			TempPerson = ActBirthPersons[a];
			ActBirthPersons[a] = ActBirthPersons[Lowest];
			ActBirthPersons[Lowest] = TempPerson;
		}//changed
	}//for a

}////////SortItems



  
//bool BdayFile::ImportFile(BdayFile *ActBirthFile, CString strFilename)
//Import files
bool BdayFile::ImportFile(BdayFile *ActBirthFile, CString strFilename)
{
	//occurs an error while importing?
	bool bError = false;

	CString strFileExtension;
	if( strFilename.ReverseFind( '.') != -1)
	{
		strFileExtension = strFilename.Right( strFilename.GetLength() - strFilename.ReverseFind( '.') - 1);
		strFileExtension.MakeLower();
		if( strFileExtension.Find( '/') != -1 || strFileExtension.Find( '\\') != -1)
		{
			strFileExtension = "";
		}
	}
	else
	{
		strFileExtension = "";
	}



	ActBirthFile->Content = GetFileContent( &strFilename);
	if( strFileExtension == "bdf")
	{
		//real xml birthday reminder file

		//use existing parsing functions
		Parse( ActBirthFile->Content, ActBirthFile, false);

		return true;
	}
	else if( strFileExtension == "jdb")
	{
		//Jarig database

		CStringArray straArray;
		CStringArray straLine;
		ActBirthFile->Content2Array( &straArray);
		

		CString strLine;
		CString strComment = "";
		for( int nPos = 0; nPos < straArray.GetSize(); nPos++)
		{
			strLine = straArray.GetAt( nPos);

			//no Comment
			if( strLine.Left( 1) != "!")
			{
				Explode( &straLine, ";", strLine);
				//size muss 4 sein
				if( straLine.GetSize() == 4)
				{
					ActBirthFile->AddPerson( straLine.GetAt(2), "Birthday", atoi( straLine.GetAt(1)), atoi( straLine.GetAt(0)), atoi( straLine.GetAt(3)));
				}
			}
			else
			{
				strComment += strLine.Right( strLine.GetLength() - 1) + "\n";
			}
			
		}
		//MessageBox( *theApp.GetMainWnd(), strComment, "Comments in Jarig file", 0);
		ActBirthFile->Author = "Jarig";
		ActBirthFile->Generator = "Jarig";
		ActBirthFile->Title = "Birthdays";
		ActBirthFile->Version = GetFileModTime( strFilename);


	}
	else if( strFileExtension == "txt")
	{
		//myBirthdayReminder
		CStringArray straArray;
		CStringArray straLine;
		ActBirthFile->Content2Array( &straArray);
		

		CString strLine;
		CString strComment = "";
		for( int nPos = 0; nPos < straArray.GetSize(); nPos++)
		{
			strLine = straArray.GetAt( nPos);

			Explode( &straLine, "|", strLine);
			if( nPos == 0)
			{
				Explode( &straLine, ":", strLine);
				if( straLine.GetAt(0) != "BirthdayReminder")
				{
					bError = true;
					Loader.LoadString( IDS_MSG_NOMYBIRTHDAYREMINDER);
					MessageBox( *theApp.GetMainWnd(), Loader, MSGBOXTITLE, MB_ICONERROR);
					break;
				}
			}
			//size muss 4 sein
			if( straLine.GetSize() == 4)
			{
				ActBirthFile->AddPerson( straLine.GetAt(0), "Birthday", straLine.GetAt(1));
			}
			
		}
		ActBirthFile->Author = "myBirthdayReminder";
		ActBirthFile->Generator = "myBirthdayReminder";
		ActBirthFile->Title = "Birthdays";
		ActBirthFile->Version = GetFileModTime( strFilename);


	}
	else if( strFileExtension == "dat")
	{
		//Anniversary
		CStringArray straArray;
		CStringArray straLine;
		ActBirthFile->Content2Array( &straArray);
		

		CString strLine;
		CString strComment = "";
		CString strEvent = "Birthday";
		CString strName = "";
		CString strYear;
		for( int nPos = 0; nPos < straArray.GetSize(); nPos++)
		{
			strLine = straArray.GetAt( nPos);

			
			//really Anniversary file?
			if( nPos == 0 && strLine != "[***CALENDAR***]")
			{
				bError = true;
				Loader.LoadString( IDS_MSG_NOANNIVERSARY);
				MessageBox( *theApp.GetMainWnd(), Loader, MSGBOXTITLE, MB_ICONERROR);

				break;
			}
			
			//if this line, then only events
			if( strLine == "[***CALENDAR***]")
			{
				strEvent = "";
				strName = "World";
			}
			//after this line -> birthdays
			else if( strLine == "[***CUSTOM***]")
			{
				strEvent = "Birthday";
				strName = "";
			}
			else
			{			
				//no special name? Take name as name
				if( strName == "")
				{
					strYear = strLine.Mid(6, 4);
					if( strYear == "8888")
						strYear = "????";
					ActBirthFile->AddPerson( strLine.Mid( 11), strEvent, atoi( strLine.Mid(0,2)), atoi( strLine.Mid( 3, 2)), strYear, 8888 );
				}
				//take name as event
				else if( strEvent == "")
				{
					strYear = strLine.Mid(6, 4);
					if( strYear == "0000")
						strYear = "????";
					ActBirthFile->AddPerson( strName, strLine.Mid( 11), atoi( strLine.Mid(0,2)), atoi( strLine.Mid( 3, 2)), strYear, 0000 );
				}
			}//no section beginning
			
		}
		ActBirthFile->Author = "Anniversary";
		ActBirthFile->Generator = "Anniversary";
		ActBirthFile->Title = "Anniversaries";
		ActBirthFile->Version = GetFileModTime( strFilename);


	}
	else if( strFileExtension == "csv")
	{
		//Comma separated values
		CSVreader csvReader;
		ActBirthFile->Content2Array( &csvReader.straArray);
		
		csvReader.Prepare();
		if( !csvReader.ParseFirstLine())
		{
			return false;
		}

		if( csvReader.lstLine.GetCount() > 0)//show csv-dialog
		{
			CImportCSV dlgCSV;
			dlgCSV.straFile.Copy( csvReader.straArray);
			dlgCSV.strFilename = strFilename;
			if( dlgCSV.DoModal() == IDOK)
			{
				CString strName, strEvent, strDate;

				int nDateDay, nDateMonth, nDateYear, nDateSep1, nDateSep2;
				CString strOut, strDate1, strDate2, strDate3, strDateDay, strDateMonth, strDateYear;
				char chDateSeparator;
				strOut = dlgCSV.strDateformat;
				//which date value is first?
				nDateDay = strOut.Find( "D");
				nDateMonth = strOut.Find( "M");
				nDateYear = strOut.Find( "Y");
				//search for separator char in date
				strOut.Replace( "D", "");
				strOut.Replace( "M", "");
				strOut.Replace( "Y", "");
				chDateSeparator = strOut.GetAt(0);


				bool bUseEvent = true;
				if( dlgCSV.strUseEvent.GetLength() > 0)
				{
					bUseEvent = false;
					strEvent = dlgCSV.strUseEvent;
				}

				POSITION pPosName1, pPosName2, pPosName3, pPosEvent, pPosDate, pPosTmp;
				

				int nA = -1;
				int nB = -1;
				int nListSize;
				int nDateSpacePos; //for space searches in date
				bool bFoundName1, bFoundName2, bFoundName3, bFoundEvent, bFoundDate;
				csvReader.Prepare();
				csvReader.nFilePos = -1;//that we don't have to separate between ParseNextLine() and ParseFirstLine()
				while( csvReader.ParseNextLine() )//cycle trough all lines
				{
					nA++;

					nB = -1;
					bFoundDate = false;
					bFoundEvent = false;
					bFoundName1 = false;
					bFoundName2 = false;
					bFoundName3 = false;
					if( dlgCSV.nUseName2 == -1 && dlgCSV.nUseName3 == -1)
						bFoundName3 = true;
					if( dlgCSV.nUseName2 == -1)
						bFoundName2 = true;
					if( !bUseEvent)
						bFoundEvent = true;
					nListSize = csvReader.lstLine.GetCount();
					do 
					{
						nB++; 
						if( nB == 0)
							pPosTmp = csvReader.lstLine.GetHeadPosition();
						else	
							csvReader.lstLine.GetNext( pPosTmp);

						if( nB == dlgCSV.nUseName1)
						{
							pPosName1 = pPosTmp;
							bFoundName1 = true;
						}
						if( nB == dlgCSV.nUseName2)
						{
							pPosName2 = pPosTmp;
							bFoundName2 = true;
						}
						if( nB == dlgCSV.nUseName3)
						{
							pPosName3 = pPosTmp;
							bFoundName3 = true;
						}
						if( nB == dlgCSV.nUseEvent)
						{
							pPosEvent = pPosTmp;
							bFoundEvent = true;
						}
						if( nB == dlgCSV.nUseDate)
						{
							pPosDate = pPosTmp;
							bFoundDate = true;
						}
					}
					while( nB < nListSize - 1 && (!bFoundName1 || !bFoundName2 || !bFoundName3 || !bFoundEvent || !bFoundDate));
					//get all positions

					if( nB < nListSize)
					{
						//name
						if( dlgCSV.nUseName2 != -1 && dlgCSV.nUseName3 != -1)
							strName = csvReader.lstLine.GetAt( pPosName1) + " " + csvReader.lstLine.GetAt( pPosName2) + " " + csvReader.lstLine.GetAt( pPosName3);
						else if( dlgCSV.nUseName2 != -1)
							strName = csvReader.lstLine.GetAt( pPosName1) + " " + csvReader.lstLine.GetAt( pPosName2);
						else
							strName = csvReader.lstLine.GetAt( pPosName1);
						strName.TrimLeft();
						strName.TrimRight();

						//Event, if not pre-specified
						if( bUseEvent)
							strEvent = csvReader.lstLine.GetAt( pPosEvent);

						//date
						strDate = csvReader.lstLine.GetAt( pPosDate);
						nDateSep1 = strDate.Find( chDateSeparator);
						nDateSep2 = strDate.Find( chDateSeparator, nDateSep1 + 1);

						strDate1 = strDate.Left( nDateSep1);
						strDate2 = strDate.Mid( nDateSep1 + 1, nDateSep2 - nDateSep1 - 1);
						//check if perhaps space is in -> ev. time after date?
						nDateSpacePos = strDate.Find( " ", nDateSep2);
						if( nDateSpacePos == -1)
							strDate3 = strDate.Right( strDate.GetLength() - nDateSep2 - 1);
						else
							strDate3 = strDate.Mid( nDateSep2 + 1, nDateSpacePos - nDateSep2 - 1);

						//DDMMYYYY
						if( nDateDay < nDateMonth && nDateDay < nDateYear && nDateMonth < nDateYear) {
							strDateDay = strDate1;
							strDateMonth = strDate2;
							strDateYear = strDate3;
						}
						//MMDDYYYY
						else if( nDateMonth < nDateDay && nDateMonth < nDateYear && nDateDay < nDateYear) {
							strDateMonth = strDate1;
							strDateDay = strDate2;
							strDateYear = strDate3;
						}
						//YYYYMMDD
						else if( nDateYear < nDateMonth && nDateYear < nDateDay && nDateMonth < nDateDay) {
							strDateYear = strDate1;
							strDateMonth = strDate2;
							strDateDay = strDate3;
						}
						//YYYYDDMM
						else if( nDateYear < nDateDay && nDateYear < nDateMonth && nDateDay < nDateMonth) {
							strDateYear = strDate1;
							strDateDay = strDate2;
							strDateMonth = strDate3;
						}

						//nothing with no date, ok?
						if( atoi( strDateDay) == 0 || atoi( strDateMonth) == 0)
						{
							strDateDay = "1";
							strDateMonth = "1";
							strDateYear = "????";
							if( !dlgCSV.bUseNoDates)
								continue;
						}

						ActBirthFile->AddPerson( strName, strEvent, atoi( strDateDay), atoi( strDateMonth), strDateYear, 0);
					}//in the list size
					else
					{
					}
				}//while all lines

				ActBirthFile->Author	= strFilename;
				ActBirthFile->Title		= "CSV data";
				ActBirthFile->Version	= "1.0";

			}//OK
			else//what should I do when user says "cancel"?
			{
				return false;
			}
		}
		else//no data found
		{
			CString strLoader;
			strLoader.LoadString( IDS_MSG_NOSCSVDATA);
			MessageBox( *theApp.GetMainWnd(), strLoader, MSGBOXTITLE, 0 + MB_ICONSTOP);
			return false;
		}
	}
	else
	{
		//don't know file
		CString strLoader;
		strLoader.LoadString( IDS_MSG_DONTKNOWFILE);
		MessageBox( *theApp.GetMainWnd(), strLoader, MSGBOXTITLE, MB_ICONEXCLAMATION);

		return false;
	}

	if( bError)
	{
		return false;
	}



	return true;
}//ImportFile



//CString BdayFile::GetFileContent(CString &strFileName)
//--
//Returns content of a file
CString BdayFile::GetFileContent(CString *strFileName)
{
	CStdioFile filFile;
	CFileException e;
	
	if( !filFile.Open( *strFileName, CFile::modeRead | CFile::typeText, &e))
	{
		CString strErrText;
		strErrText.LoadString( IDS_PARSE_FILEOPEN_ERROR_TEXT);

		MessageBox(0, strErrText + "\n" + *strFileName, MSGBOXTITLE, 0 + MB_ICONSTOP );
		return "";
	}
	CString strContent, strInput;

    while( filFile.ReadString( strInput))
       strContent += strInput + "\n";

	filFile.Close();

	return strContent;
}//GetFileContent





//bool BdayFile::Content2Array( CStringArray *straArray)
//----------------
//Wandelt Dateiinhalt in zeilenweisen Array um
bool BdayFile::Content2Array( CStringArray *straArray)
{
	int nStart = 0;
	int nNext = Content.Find("\n");

//	MessageBox( *theApp.GetMainWnd(), Content, "Content2Array", 0);
/*	CString strTest;
	strTest.Format( "%d", nNext);
	MessageBox( *theApp.GetMainWnd(), strTest, "Content2Array", 0);
*/
	CString strLine = "";
	CString strTest = "";
	while( nNext != -1)
	{
		strLine = Content.Mid( nStart, nNext - nStart);
		strLine.TrimLeft();
		strLine.TrimRight();
		//strTest.Format( "%d - %d", nStart, nNext);
		//MessageBox( *theApp.GetMainWnd(), strLine, "Content2Array", 0);
		if( strLine.GetLength() > 0)
			straArray->Add( strLine);

		nStart = nNext + 1;
		nNext = Content.Find("\n", nStart);
	}
	strLine = Content.Mid( nStart);
	if( strLine.GetLength() > 0)
		straArray->Add( strLine);
	
	return true;
}//Content2Array

	




bool BdayFile::Explode( CStringArray *straArray, CString strSeperator, CString strString)
{
	straArray->RemoveAll();

	CString strPart = "";
	int nStart = 0;
	int nNext = strString.Find( strSeperator);
	
	while( nNext != -1)
	{
		strPart = strString.Mid( nStart, nNext - nStart);

		straArray->Add( strPart);

		nStart = nNext + 1;
		nNext = strString.Find( strSeperator, nStart);
	}
	strPart = strString.Mid( nStart);
	straArray->Add( strPart);


	return true;
}

//bool BdayFile::AddPerson(CString strName, CString strEvent, CString strDate)
//------------
//Add a Person to the birthday file
bool BdayFile::AddPerson(CString strName, CString strEvent, CString strDate)
{
	CountPersons++;
	ActBirthPersons[CountPersons].Name = strName;
	ActBirthPersons[CountPersons].Event = strEvent;
	ActBirthPersons[CountPersons].Date.DateAsString = strDate;
	StringToTime( &ActBirthPersons[ CountPersons], &ActBirthPersons[CountPersons].Date.DateAsString);

	return true;
}

bool BdayFile::AddPerson(CString strName, CString strEvent, int nDay, int nMonth, int nYear, int nAllYear)
{
	CountPersons++;
	ActBirthPersons[CountPersons].Name = strName;
	ActBirthPersons[CountPersons].Event = strEvent;
	ActBirthPersons[CountPersons].Date.day = nDay;
	ActBirthPersons[CountPersons].Date.month = nMonth;

	CString strYear;
	strYear.Format( "%d", nYear);
	ActBirthPersons[CountPersons].Date.year = strYear;

	ActBirthPersons[CountPersons].Date.DateAsString = Time2String( nDay, nMonth, strYear, nAllYear);

	return true;
}

bool BdayFile::AddPerson(CString strName, CString strEvent, int nDay, int nMonth, CString strYear, int nAllYear)
{
	CountPersons++;
	ActBirthPersons[CountPersons].Name = strName;
	ActBirthPersons[CountPersons].Event = strEvent;
	ActBirthPersons[CountPersons].Date.day = nDay;
	ActBirthPersons[CountPersons].Date.month = nMonth;

	ActBirthPersons[CountPersons].Date.year = strYear;

	ActBirthPersons[CountPersons].Date.DateAsString = Time2String( nDay, nMonth, strYear, nAllYear);

	return true;
}


//CString BdayFile::Time2String(int nDay, int nMonth, CString strYear, int nAllYear)
//----------------
//Converts a given time to a string containing the information
//use: for display
CString BdayFile::Time2String(int nDay, int nMonth, CString strYear, int nAllYear)
{
	CString strTimestring = "";
	CString strDummy = "";

	if( nDay < 10)
		strTimestring += "0";
	strDummy.Format( "%d", nDay);
	strTimestring += strDummy + ".";

	if( nMonth < 10)
		strTimestring += "0";
	strDummy.Format( "%d", nMonth);
	strTimestring += strDummy + ".";

	if( atoi( strYear) != nAllYear && strYear != "????")
	{
		if( atoi( strYear) < 10)
			strTimestring += "000";
		else if( atoi( strYear) < 100)
			strTimestring += "00";
		else if( atoi( strYear) < 1000)
			strTimestring += "0";

		strTimestring += strYear;
	}
	else
	{
		strTimestring += "????";
	}

	return strTimestring;
}


//CString BdayFile::GetFileModTime(CString strFilename)
//----------------
//returns a string containing the date the file was created
CString BdayFile::GetFileModTime(CString strFilename)
{
		FILETIME modificationTime;
		_SYSTEMTIME systFileTime;

		HANDLE hFile;
		hFile = CreateFile( strFilename, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0);
		GetFileTime(hFile, NULL, NULL, &modificationTime);
		CloseHandle(hFile);
		FileTimeToSystemTime( &modificationTime, &systFileTime);

		CString strDummy;
		strDummy.Format( "%d", systFileTime.wYear);

		return Time2String( int( systFileTime.wDay), int( systFileTime.wMonth), strDummy);
}
