// birthdayDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "birthday.h"
#include "birthdayDlg.h"
#include "EditDlg.h"
#include "Key.h"
#include "OptionsDlg.h"
#include "SystemTray.h"
#include "Hyperlink.h"
#include "BalloonHelp.h"

#include <sys/types.h>//drag n drop
#include <sys/stat.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

struct ItemData
{
public:
	ItemData() : arrpsz( NULL ), dwData( NULL ) {}

	LPTSTR* arrpsz;
	DWORD dwData;

private:
	// ban copying.
	ItemData( const ItemData& );
	ItemData& operator=( const ItemData& );
};
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_BUTTON_WEB, m_button_web);
	DDX_Control(pDX, IDC_EMAIL, m_hyperlink_email);
	DDX_Control(pDX, IDC_EDIT_PATH, m_edit_path);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_BUTTON_WEB, OnButtonWeb)
	ON_EN_SETFOCUS(IDC_EDIT_PATH, OnSetfocusEditPath)
	ON_WM_MOVING()
	ON_WM_SIZE()
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////
//AboutDialog

void CAboutDlg::OnButtonWeb() 
{
	if( !bJustlook)
	{
		ShellExecute(0,"open","http://www.cweiske.de",NULL,NULL,SW_SHOWNORMAL);
	}
}

void CAboutDlg::OnMoving(UINT nSide, LPRECT lpRect) 
{
	if(IsLoaded == true && IsMagnetOn == true && GetAsyncKeyState(VK_CONTROL) == 0 && GetAsyncKeyState(VK_SHIFT) == 0)
	{
		NewPos = lpRect;
		GetWindowRect(WindowPos);

		WindowSize.right = NewPos->right - NewPos->left;
		WindowSize.bottom = NewPos->bottom - NewPos->top;

		SystemParametersInfo(SPI_GETWORKAREA,0,ScreenSize,0);

		RealPos.top = RealPos.top - WindowPos.top + NewPos->top;
		RealPos.left = RealPos.left - WindowPos.left + NewPos->left;
		RealPos.bottom = RealPos.top + WindowSize.bottom;
		RealPos.right = RealPos.left + WindowSize.right;


		if(!(abs(ScreenSize.top + RealPos.top) <= MagnetSize))
		{
			if(MagnetOnTop)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnTop = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->top = ScreenSize.top;
			NewPos->bottom = NewPos->top + WindowSize.bottom;
			MagnetOnTop = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.left + RealPos.left) <= MagnetSize))
		{
			if(MagnetOnLeft)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnLeft = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->left = ScreenSize.left;
			NewPos->right = NewPos->left + WindowSize.right;
			MagnetOnLeft = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.bottom - RealPos.bottom) <= MagnetSize))
		{
			if(MagnetOnBottom)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnBottom = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->bottom = ScreenSize.bottom;
			NewPos->top = NewPos->bottom - WindowSize.bottom;
			MagnetOnBottom = true;
			MagnetNowOn = true;
		}
		
		if(!(abs(ScreenSize.right - RealPos.right) <= MagnetSize))
		{
			if(MagnetOnRight)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnRight = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->right = ScreenSize.right;
			NewPos->left = NewPos->right - WindowSize.right;
			MagnetOnRight = true;
			MagnetNowOn = true;
		}


		if(MagnetNowOn)
		{
			lpRect = NewPos;
			MagnetNowOn = false;
		}
		else
		{
			GetWindowRect(RealPos);
		}
		
	}
	else
	{
		GetWindowRect(RealPos);
	}

	CDialog::OnMoving(nSide, lpRect);

	if(!IsLoaded)
	{
		GetWindowRect(RealPos);
		MagnetOnTop = false;
		MagnetOnLeft = false;
		MagnetOnRight = false;
		MagnetOnBottom = false;
		IsLoaded = true;

	}
}

void CAboutDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	GetWindowRect(RealPos);
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_edit_path.SetWindowText( __argv[0]);
	IsMagnetOn = true;
	MagnetSize = 20;
	IsLoaded = false;
			
	if( !bJustlook)
	{
		m_hyperlink_email.SetURL( "mailto:birthday@cweiske.de");
		m_button_web.EnableWindow( true);
		m_hyperlink_email.EnableWindow( true);
	}
	else
	{
		m_button_web.EnableWindow( false);
		m_hyperlink_email.EnableWindow( false);
	}

	return TRUE;
}

void CAboutDlg::OnSetfocusEditPath() 
{
	m_edit_path.SetSel(0,-1,false);	
}




/////////////////////////////////////////////////////////////////////////////
// CBirthdayDlg Dialogfeld

CBirthdayDlg::CBirthdayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBirthdayDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBirthdayDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBirthdayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBirthdayDlg)
	DDX_Control(pDX, IDHELP, m_button_help);
	DDX_Control(pDX, IDC_BUTTON_OPTIONS, m_button_options);
	DDX_Control(pDX, IDC_BUTTON_OPENOTHER, m_button_openother);
	DDX_Control(pDX, IDC_BUTTON_EDIT, m_button_edit);
	DDX_Control(pDX, IDC_EDIT_VERSION, m_edit_version);
	DDX_Control(pDX, IDC_EDIT_FILEPATH, m_edit_filepath);
	DDX_Control(pDX, IDC_EDIT_TITLE, m_edit_title);
	DDX_Control(pDX, IDC_EDIT_AUTHOR, m_edit_author);
	DDX_Control(pDX, IDC_LIST_EVENTS, m_list_events);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBirthdayDlg, CDialog)
	//{{AFX_MSG_MAP(CBirthdayDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_MOVING()
	ON_BN_CLICKED(IDC_BUTTON_EDIT, OnButtonEdit)
	ON_BN_CLICKED(IDC_BUTTON_OPENOTHER, OnButtonOpenother)
	ON_WM_HELPINFO()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_BUTTON_OPTIONS, OnButtonOptions)
	ON_BN_CLICKED(IDHELP, OnHelp)
	ON_WM_DROPFILES()
	ON_WM_TIMER()
	ON_WM_TIMECHANGE()
	ON_WM_SHOWWINDOW()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_EVENTS, OnDblclkListEvents)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBirthdayDlg Nachrichten-Handler


BOOL CBirthdayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	IsLoaded = false;

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.
	
	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->EnableMenuItem(2,MF_BYPOSITION | MF_GRAYED);
		pSysMenu->EnableMenuItem(4,MF_BYPOSITION | MF_GRAYED);

		pSysMenu->InsertMenu(1,MF_SEPARATOR);
			Loader.LoadString(IDS_ALWAYSONTOP);
		pSysMenu->InsertMenu(1,MF_UNCHECKED,IDM_MNU_ONTOP, Loader);
			Loader.LoadString(IDS_MAGNETBORDER);
		pSysMenu->InsertMenu(1,MF_UNCHECKED,IDM_MNU_MAGNET, Loader);

			Loader.LoadString(IDS_ABOUTBOX);
		if (!Loader.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, Loader);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	bJustlook = false;
	AutoStart = false;
	IsOnTop = false;
	IsMagnetOn = false;
	MagnetSize = 20;
	IsLoaded = false;
	ChangeMagnetBorder();

	LoadRegistries();
	
	//close when already started today and autorun
	CTime tmTime = CTime::GetCurrentTime();
	Loader = tmTime.Format( "%d.%m.%Y");
	if( AutoStart && bOptRunonlyonce && strOptRunonlyonce == Loader)
	{
		exit( EXIT_SUCCESS);
	}


	SmallIcons.Create(16, 16, TRUE, 10, 10);
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_STAR));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_YELLOW));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_GREEN));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_BLUE));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_1));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_2));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_3));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_M1));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_M2));
	SmallIcons.Add( AfxGetApp()->LoadIcon(IDI_LIST_M3));

	ActBirthFile.InitVariables();
/*	ActBirthFile.ShowLast = 10;
	ActBirthFile.ShowNext = 30;
	ActBirthFile.Author = "";
	ActBirthFile.Content = "";
	ActBirthFile.CountPersons = -1;
	ActBirthFile.Generator = "";
	ActBirthFile.Length = 0;
	ActBirthFile.Version = "";
*/
	//standardfile mit akt. Programmpfad
	CString strProgpath = __argv[0];
	strProgpath = strProgpath.Left( strProgpath.ReverseFind( '\\'));
	if( strProgpath.Right( 1) != "\\")
	{
		strProgpath = strProgpath + "\\";
	}
	ActBirthFile.FileName = strProgpath + "birthday.bdf";


	//Helpfile path + filename
	strHelpfile = strProgpath + "birthday.chm";


	//standardfile aus registry lesen ->berschreibt erstes standardfile
	CString KeyEntry;
	if(bdr_regenabled && bdr_savefile)
	{
		CKey key;
		key.m_hKey = HKEY_CURRENT_USER;
		key.Open(HKEY_CURRENT_USER,"Software\\RealDreams\\BirthdayReminder");
		key.GetStringValue( KeyEntry, "BirthdayFile");
		key.Close();
	}

	CFileStatus FileStatus;
	//wenn explizit angegeben, dann natrlich file aus command line verwenden
	if(__argc > 1)
	{
		CString Tst, NewFile;
		//loop
		for(int a = 1; a < __argc; a++)
		{
			Tst = __argv[a];
			Tst.TrimLeft();
			Tst.TrimRight();
			if(Tst == "/autostart")
			{
				AutoStart = true;
			}
			else if( Tst == "/justlook")
			{
				bJustlook = true;
			}
			else
			{
				NewFile = NewFile + " " + __argv[a];
			}
		}//loop with for
		if( NewFile.GetLength() > 1)
		{
			NewFile = NewFile.Mid( 1);
			if(CFile::GetStatus( NewFile, FileStatus) != 0)
				KeyEntry = NewFile;
		}
	}

	if(CFile::GetStatus( KeyEntry, FileStatus) != 0)
		ActBirthFile.FileName = KeyEntry;
	int exist = CFile::GetStatus( ActBirthFile.FileName, FileStatus);
	int ant = IDNO;
	if(exist == 0)
	{
		bool bOpenFileDialog = true;
		LPCTSTR lpszDefExt = "*.bdf";
		LPCTSTR lpszFileName = "birthday.bdf";
		DWORD dwFlags = OFN_HIDEREADONLY ;
		Loader.LoadString(IDS_FILTER_OPEN);
		LPCTSTR	lpszFilter = Loader;
		CWnd* pParentWnd = 0;

		CFileDialog FileDlg(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd);
		FileDlg.m_ofn.lpstrInitialDir = __argv[0];
		Loader.LoadString(IDS_DLG_SELECTNEWFILE);
		FileDlg.m_ofn.lpstrTitle = Loader;

		ant = FileDlg.DoModal();

		if(ant == IDOK)
		{
			ActBirthFile.FileName = FileDlg.GetPathName();

			//check if file exists, if not - ask for create new one
			exist = CFile::GetStatus( ActBirthFile.FileName, FileStatus);
			if( exist == 0)
			{
				Loader.LoadString(IDS_MSG_CREATENEWFILE);
				Loader = Loader + "\nFile:\n" + ActBirthFile.FileName;
				if( MessageBox( Loader, MSGBOXTITLE, MB_YESNO + MB_ICONQUESTION) == IDYES)
				{
					CFile newfile;
					CFileException fexFileException;
					if( !newfile.Open( ActBirthFile.FileName, CFile::modeCreate | CFile::modeNoTruncate, &fexFileException))
					{
						CString strErrText;
						strErrText.LoadString( IDS_PARSE_FILEOPEN_ERROR_TEXT);

						strErrText.Format( "%d", fexFileException.m_cause);
						MessageBox( strErrText, MSGBOXTITLE, 0 + MB_ICONSTOP );
						
					}
					newfile.Close();
				}
			}


			//ask if this file should be opened always
			exist = CFile::GetStatus( ActBirthFile.FileName, FileStatus);
			if( exist != 0)
			{	
				m_button_edit.EnableWindow( true);

				Loader.LoadString(IDS_FILEASSTANDARD);
				if(MessageBox(Loader, MSGBOXTITLE, MB_YESNO + MB_ICONQUESTION) == IDYES)
				{
						CheckRegistryFolders();
						CString KeyEntry;
						CKey key;
						key.m_hKey = HKEY_CURRENT_USER;
						key.Open(HKEY_CURRENT_USER,"Software\\RealDreams\\BirthdayReminder");
						key.SetStringValue(FileDlg.GetPathName(), "BirthdayFile");
						key.SetStringValue("1", "RegAllowed");
						key.Close();
						bdr_savefile = true;
						bdr_regenabled = true;
				}
			}//exists file?

		}
	}

	CreateListHeaders();
	//Wenn Datei existiert, dann laden
	if(exist == 1)
	{
		ActBirthFile.StartParsing(&ActBirthFile, false);
		ListOut();
	}
	else
	{
		ActBirthFile.FileName = "";
	}

	DisplayDate();

	//Auto-Update der Zeit
	SetTimer( 2000, ITIMER, NULL);

	if( bJustlook || ( AutoStart && bOptJustlook))
	{
		ActivateJustlook();
	}
	else
	{
		if( exist == 1 && ActBirthFile.CountPersons == -1)
		{
			bAutoEdit = true;
			OnButtonEdit();
		}
		else
		{
			bAutoEdit = false;
		}
	}


	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}//OnInitDialog


void CBirthdayDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.bJustlook = bJustlook;
		dlgAbout.DoModal();
	}
	else if(nID == IDM_MNU_MAGNET)
		ChangeMagnetBorder();
	else if(nID == IDM_MNU_ONTOP)
		ChangeOnTop();
	else if( nID == SC_MINIMIZE && bOptOK2Tray)
	{
		Window2Tray();
	}
	else
	{
		
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CBirthdayDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CBirthdayDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBirthdayDlg::OnMoving(UINT nSide, LPRECT lpRect)
{
	if(IsLoaded == true && IsMagnetOn == true && GetAsyncKeyState(VK_CONTROL) == 0 && GetAsyncKeyState(VK_SHIFT) == 0)
	{
		NewPos = lpRect;
		GetWindowRect(WindowPos);

		WindowSize.right = NewPos->right - NewPos->left;
		WindowSize.bottom = NewPos->bottom - NewPos->top;

		SystemParametersInfo(SPI_GETWORKAREA,0,ScreenSize,0);

		RealPos.top = RealPos.top - WindowPos.top + NewPos->top;
		RealPos.left = RealPos.left - WindowPos.left + NewPos->left;
		RealPos.bottom = RealPos.top + WindowSize.bottom;
		RealPos.right = RealPos.left + WindowSize.right;


		if(!(abs(ScreenSize.top + RealPos.top) <= MagnetSize))
		{
			if(MagnetOnTop)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnTop = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->top = ScreenSize.top;
			NewPos->bottom = NewPos->top + WindowSize.bottom;
			MagnetOnTop = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.left + RealPos.left) <= MagnetSize))
		{
			if(MagnetOnLeft)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnLeft = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->left = ScreenSize.left;
			NewPos->right = NewPos->left + WindowSize.right;
			MagnetOnLeft = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.bottom - RealPos.bottom) <= MagnetSize))
		{
			if(MagnetOnBottom)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnBottom = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->bottom = ScreenSize.bottom;
			NewPos->top = NewPos->bottom - WindowSize.bottom;
			MagnetOnBottom = true;
			MagnetNowOn = true;
		}
		
		if(!(abs(ScreenSize.right - RealPos.right) <= MagnetSize))
		{
			if(MagnetOnRight)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnRight = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->right = ScreenSize.right;
			NewPos->left = NewPos->right - WindowSize.right;
			MagnetOnRight = true;
			MagnetNowOn = true;
		}


		if(MagnetNowOn)
		{
			lpRect = NewPos;
			MagnetNowOn = false;
		}
		else
		{
			GetWindowRect(RealPos);
		}
		
	}
	else
	{
		GetWindowRect(RealPos);
	}

	CDialog::OnMoving(nSide, lpRect);

	if(!IsLoaded)
	{
		GetWindowRect(RealPos);
		MagnetOnTop = false;
		MagnetOnLeft = false;
		MagnetOnRight = false;
		MagnetOnBottom = false;
		IsLoaded = true;

	}
}

void CBirthdayDlg::ChangeMagnetBorder()
{
	IsMagnetOn = !IsMagnetOn;

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		if(IsMagnetOn)
			pSysMenu->CheckMenuItem(IDM_MNU_MAGNET,MF_CHECKED);
		else
			pSysMenu->CheckMenuItem(IDM_MNU_MAGNET,MF_UNCHECKED);
	}

}

void CBirthdayDlg::ChangeOnTop()
{
	IsOnTop = !IsOnTop;

	if(IsOnTop)
		CDialog::SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE + SWP_NOMOVE);
	else
		CDialog::SetWindowPos(&wndNoTopMost,0,0,0,0,SWP_NOSIZE + SWP_NOMOVE);
	
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		if(IsOnTop)
			pSysMenu->CheckMenuItem(IDM_MNU_ONTOP,MF_CHECKED);
		else
			pSysMenu->CheckMenuItem(IDM_MNU_ONTOP,MF_UNCHECKED);
	}
									
}




/////////////////////////////////////////////////////////////////////////////
// Output functions

void CBirthdayDlg::TextOut() //Output: Data to Textfield
{
	CString Out;
	Out = "Author: " + ActBirthFile.Author + "\r\n";
	Out = Out + "Generator: " + ActBirthFile.Generator + "\r\n";
	Out = Out + "Version: " + ActBirthFile.Version + "\r\n";
	Out = Out + "\r\n";
	for(int a=0; a <= ActBirthFile.CountPersons; a++)
	{
		Out = Out + ActBirthFile.ActBirthPersons[a].Name + "\t";
		Out = Out + ActBirthFile.ActBirthPersons[a].Date.DateAsString + "\t";
		Out = Out + ActBirthFile.ActBirthPersons[a].Event + "\r\n";
	}

	m_edit_view.SetWindowText(Out);

}


void CBirthdayDlg::ListOut()  //Output: Data to ListCtrl
{
	CString buffer, buffer2, ShowYear, strWeekday;
	int ActItem, ActImage, nItems;
	LPTSTR extra;
	

	m_list_events.DeleteAllItems();
	m_list_events.SetImageList( &SmallIcons, LVSIL_SMALL);

	if( ActBirthFile.FileName != "")
	{
		COleDateTime tmTmp;
		CString strLocaltime, strExampleDate, strYear;
		bool bShortYear, bShortMonth, bShortDay;
		int nDateLength = 8;

		tmTmp = COleDateTime::GetCurrentTime();
		tmTmp.SetDate( tmTmp.GetYear(), 11, 22);
		strYear.Format( "%d", tmTmp.GetYear());
		strLocaltime = tmTmp.Format( VAR_DATEVALUEONLY);
		if( strLocaltime.Find( strYear) == -1)
			bShortYear = true;
		else
		{
			bShortYear = false;
		}
		//for replacing, is needed!!!!!
		tmTmp.SetDate( 3333, 11, 22);
		strExampleDate = tmTmp.Format( VAR_DATEVALUEONLY);
		nDateLength = strExampleDate.GetLength();
		
		//Check if 2-digit year or 4-digit
		//Check if month is with leading zero
		tmTmp.SetDate( tmTmp.GetYear(), 1, 22);
		strLocaltime = tmTmp.Format( VAR_DATEVALUEONLY);
		if( strLocaltime.GetLength() != nDateLength)
			bShortMonth = true;
		else
			bShortMonth = false;
		//Check if day is with leading zero
		tmTmp.SetDate( tmTmp.GetYear(), 11, 2);
		strLocaltime = tmTmp.Format( VAR_DATEVALUEONLY);
		if( strLocaltime.GetLength() != nDateLength)
			bShortDay = true;
		else
			bShortDay = false;
		

		nItems = 0;
		for( int a=0; a <= ActBirthFile.CountPersons; a++)
		{
			if(ActBirthFile.ActBirthPersons[a].daydiffnext <= ActBirthFile.ShowNext || ActBirthFile.ActBirthPersons[a].daydifflast <= ActBirthFile.ShowLast)
			{

				if( ActBirthFile.ActBirthPersons[a].daydifflast <= ActBirthFile.ShowLast && ActBirthFile.ActBirthPersons[a].daydifflast > 0)
				{
					buffer2.Format("%d", ActBirthFile.ActBirthPersons[a].daydifflast);
					buffer2 = "0" + buffer2;
					buffer.Format("%d", 1000 - ActBirthFile.ActBirthPersons[a].daydifflast);
					buffer = "0" + buffer;
					extra = "-";
					if(ActBirthFile.ActBirthPersons[a].daydifflast == 1)
						ActImage = 7;
					else if(ActBirthFile.ActBirthPersons[a].daydifflast == 2)
						ActImage = 8;
					else if(ActBirthFile.ActBirthPersons[a].daydifflast == 3)
						ActImage = 9;
					else
						ActImage = 3;
					ShowYear.Format("%d",ActBirthFile.ActBirthPersons[a].yeardiff - 1);
					strWeekday	= ActBirthFile.ActBirthPersons[a].strLastWeekday;
				}
				else
				{
					buffer.Format("%d", ActBirthFile.ActBirthPersons[a].daydiffnext);
					buffer = "1" + buffer;
					buffer2 = buffer;
					extra = " ";

					if(ActBirthFile.ActBirthPersons[a].daydiffnext == 0)
						ActImage = 0;
					else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 1)
						ActImage = 4;
					else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 2)
						ActImage = 5;
					else if(ActBirthFile.ActBirthPersons[a].daydiffnext == 3)
						ActImage = 6;
					else if(ActBirthFile.ActBirthPersons[a].daydiffnext <= 10)
						ActImage = 1;
					else 
						ActImage = 2;

					ShowYear.Format("%d",ActBirthFile.ActBirthPersons[a].yeardiff);
					strWeekday	= ActBirthFile.ActBirthPersons[a].strNextWeekday;
				}

				if(buffer.GetLength() == 2)
					buffer.Insert(1, "00");
				else if(buffer.GetLength() == 3)
					buffer.Insert(1, "0");
				

				nItems++;
				ActItem = m_list_events.InsertItem(a, buffer, ActImage);
				m_list_events.SetItemText(ActItem, 1, extra + buffer2.Mid(1));

				if(ActBirthFile.ActBirthPersons[a].Date.year.Right(1) != "?") 
					m_list_events.SetItemText(ActItem, 2, ShowYear);

				m_list_events.SetItemText(ActItem, 3, ActBirthFile.ActBirthPersons[a].Event);
				m_list_events.SetItemText(ActItem, 4, ActBirthFile.ActBirthPersons[a].Name );

				//format time to local...
				if( ActBirthFile.ActBirthPersons[a].Date.year.Right(1) != "?") 
				{
					//tmTmp.SetDate( atoi( ActBirthFile.ActBirthPersons[a].Date.year), ActBirthFile.ActBirthPersons[a].Date.month, ActBirthFile.ActBirthPersons[a].Date.day);
					//strLocaltime = tmTmp.Format( VAR_DATEVALUEONLY);
					//year
					strLocaltime = strExampleDate;
					Loader = ActBirthFile.ActBirthPersons[a].Date.year;
					if( bShortYear && Loader.GetLength() > 2)
						Loader = Loader.Right(2);
					strLocaltime.Replace( "3333", Loader);
					//month
					Loader.Format( "%d", ActBirthFile.ActBirthPersons[a].Date.month);
					if( !bShortMonth && Loader.GetLength() == 1)
						Loader = "0" + Loader;
					strLocaltime.Replace( "11", Loader);
					//day
					Loader.Format( "%d", ActBirthFile.ActBirthPersons[a].Date.day);
					if( !bShortDay && Loader.GetLength() == 1)
						Loader = "0" + Loader;
					strLocaltime.Replace( "22", Loader);
				}
				else
				{
					tmTmp.SetDate( 8888, ActBirthFile.ActBirthPersons[a].Date.month, ActBirthFile.ActBirthPersons[a].Date.day);
					strLocaltime = tmTmp.Format( VAR_DATEVALUEONLY);
					if( bShortYear)
						strLocaltime.Replace( "8888", "??");
					else
						strLocaltime.Replace( "8888", "????");
				}
				strLocaltime	= strWeekday + ", " + strLocaltime;

				m_list_events.SetItemText(ActItem, 5, strLocaltime);
				


			}

		}//for Items
		if(nItems == 0 && AutoStart == true && bdr_closeonautorun == true)
		{
			exit(EXIT_SUCCESS);
		}
			
		m_edit_author.SetWindowText( ActBirthFile.Author);
		m_edit_title.SetWindowText( ActBirthFile.Title);
		m_edit_filepath.SetWindowText( ActBirthFile.FileName);
		m_edit_version.SetWindowText( ActBirthFile.Version);

		m_button_edit.EnableWindow( true);
	}//if there is a file

}


/////////////////////////////////////////////////////////////////////////////
// List functions

//Add Headers to ListCtrl
void CBirthdayDlg::CreateListHeaders()
{
	
	m_list_events.InsertColumn(0, "", LVCFMT_CENTER, 18, -1);
	Loader.LoadString(IDS_LIST_HEADER_DAYDIFF);
	m_list_events.InsertColumn(1, Loader, LVCFMT_CENTER, 40, -1);
	Loader.LoadString(IDS_LIST_HEADER_YEARDIFF);
	m_list_events.InsertColumn(2, Loader, LVCFMT_RIGHT, 40, -1);

	Loader.LoadString(IDS_LIST_HEADER_EVENT);
	m_list_events.InsertColumn(3, Loader, LVCFMT_LEFT, 115, -1);
	Loader.LoadString(IDS_LIST_HEADER_NAME);
	m_list_events.InsertColumn(4, Loader, LVCFMT_LEFT, 180, -1);
	Loader.LoadString(IDS_LIST_HEADER_DATE);
	m_list_events.InsertColumn(5, Loader, LVCFMT_RIGHT, 95, -1);

	//  | LVS_EX_FLATSB | LVS_EX_HEADERDRAGDROP	
	m_list_events.SetExtendedStyle(LVS_EX_FULLROWSELECT );


	
	//Set width of columns to user specs
	if( bdr_regenabled && strListHeaders.GetLength() > 0) {
		CString strWidth	= "";
		int nOldPos			= 0;
		int nNewPos			= 0;
		int nWidth			= 0;
		int nCol			= 0;
		while( nNewPos = strListHeaders.Find( "|", nOldPos)) {
			if( nNewPos == -1) {
				break;
			}
			strWidth	= strListHeaders.Mid( nOldPos, nNewPos - nOldPos);
			nWidth		= atoi( strWidth);
			m_list_events.SetColumnWidth( nCol, nWidth);
			
			nOldPos		= nNewPos + 1;
			nCol++;
		}
	}
}//void CBirthdayDlg::CreateListHeaders()






void CBirthdayDlg::OnButtonEdit() 
{
	CEditDlg EditWindow;
	EditWindow.ActBirthFile = ActBirthFile;
	EditWindow.IsMagnetOn = IsMagnetOn;
	EditWindow.IsOnTop = IsOnTop;
	
	
	EditWindow.strHelpfile = strHelpfile;
	EditWindow.bAutoEdit = bAutoEdit;

	int ant = EditWindow.DoModal();
	if(ant == IDOK)
	{
		ActBirthFile.StartParsing(&ActBirthFile, false);
		ListOut();
	}
	ChangeMagnetBorder();
	ChangeMagnetBorder();
	ChangeOnTop();
	ChangeOnTop();
}

void CBirthdayDlg::OnButtonOpenother() 
{
	bool bOpenFileDialog = true;
	LPCTSTR lpszDefExt = "*.bdf";
	LPCTSTR lpszFileName = "birthday.bdf";
	DWORD dwFlags = OFN_HIDEREADONLY + OFN_CREATEPROMPT + !OFN_ENABLEHOOK;
	Loader.LoadString(IDS_FILTER_OPEN);
	LPCTSTR	lpszFilter = Loader;
	CWnd* pParentWnd = 0;

	CFileDialog FileDlg(bOpenFileDialog, lpszDefExt, lpszFileName, dwFlags, lpszFilter, pParentWnd);
	if(ActBirthFile.FileName != "")
		FileDlg.m_ofn.lpstrInitialDir = ActBirthFile.FileName;
	else
		FileDlg.m_ofn.lpstrInitialDir = __argv[0];

	Loader.LoadString(IDS_DLG_OPENOTHER);
	FileDlg.m_ofn.lpstrTitle = Loader;

	int ant = FileDlg.DoModal();

/*	if(ant == IDOK)
	{
		Loader.LoadString(IDS_FILEASSTANDARD);
		if(MessageBox(Loader, MSGBOXTITLE, MB_YESNO + MB_ICONQUESTION) == IDYES)
		{
				CString KeyEntry;
				CKey key;
				key.m_hKey = HKEY_CURRENT_USER;
				key.Open(HKEY_CURRENT_USER,"Software\\RealDreams\\BirthdayReminder");
				key.SetStringValue(FileDlg.GetPathName(), "BirthdayFile");
				key.SetStringValue("1", "RegAllowed");
				key.Close();
				bdr_savefile = true;
				bdr_regenabled = true;
		}
		ActBirthFile.FileNameOld = ActBirthFile.FileName;
		ActBirthFile.FileName = FileDlg.GetPathName();
		ActBirthFile.StartParsing(&ActBirthFile, false);
		ListOut();
*/
	if(ant == IDOK)
	{
		OpenFile( ActBirthFile.FileName = FileDlg.GetPathName());
	}

}

BOOL CBirthdayDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	return ShowHelpDialog( "001 - welcome.htm>Main");
}

void CBirthdayDlg::CheckRegistryFolders()
{
   	LONG		lRv;
	HKEY		hKey;
	lRv = RegCreateKeyEx(HKEY_CURRENT_USER,TEXT("SOFTWARE\\RealDreams\\BirthdayReminder"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL);
	RegCloseKey(hKey);
	lRv = RegCreateKeyEx(HKEY_CURRENT_USER,TEXT("SOFTWARE\\RealDreams\\Programs"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL);
	RegCloseKey(hKey);
}


void CBirthdayDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	GetWindowRect(RealPos);
}


void CBirthdayDlg::RegExtLinkAdd()
{
	CString AppName = __argv[0];
	AppName.MakeLower();

   	LONG		lRv;
	HKEY		hKey;
	lRv = RegCreateKeyEx( HKEY_CLASSES_ROOT, TEXT(".bdf"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL);
	lRv = RegCreateKeyEx( HKEY_CLASSES_ROOT, TEXT("birthdayfile"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL);
	lRv = RegCreateKeyEx( HKEY_CLASSES_ROOT, TEXT("birthdayfile\\DefaultIcon"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL);
	lRv = RegCreateKeyEx( HKEY_CLASSES_ROOT, TEXT("birthdayfile\\shell\\open\\command"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL);
	RegCloseKey(hKey);

	CKey key;
	key.m_hKey = HKEY_CLASSES_ROOT;
	key.Open(HKEY_CLASSES_ROOT,".bdf");
	key.SetStringValue("birthdayfile", "");
	key.SetStringValue("text/xml", "Content Type");
	key.Close();

	key.Open(HKEY_CLASSES_ROOT,"birthdayfile");
	key.SetStringValue("birthday file", "");
	key.Close();

	key.Open(HKEY_CLASSES_ROOT,"birthdayfile\\DefaultIcon");
	key.SetStringValue(AppName + ",0", "");
	key.Close();

	key.Open(HKEY_CLASSES_ROOT,"birthdayfile\\shell\\open\\command");
	key.SetStringValue(AppName + " %1", "");
	key.Close();
}

void CBirthdayDlg::RegExtLinkDelete()
{
	bool error = false;
	HKEY key;
	long result;
	Loader.LoadString(IDS_MSG_NOREGEXTDELETE);
	//delete values
	//	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, "birthdayfile\\shell\\open\\command", 0, KEY_SET_VALUE, &key);
	//	if(result == ERROR_SUCCESS)
	//		RegDeleteValue( key, "");
	//	else
	//		MessageBox(Loader, "RD birthday reminder", MB_ICONERROR);
	//	RegCloseKey( key);
	//
	//	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, "birthdayfile\\DefaultIcon", 0, KEY_SET_VALUE, &key);
	//	if(result == ERROR_SUCCESS)
	//		RegDeleteValue( key, "");
	//	else
	//		MessageBox(Loader, "RD birthday reminder", MB_ICONERROR);
	//	RegCloseKey( key);
	//
	//	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, "birthdayfile", 0, KEY_SET_VALUE, &key);
	//	if(result == ERROR_SUCCESS)
	//		RegDeleteValue( key, "");
	//	else
	//		MessageBox(Loader, "RD birthday reminder", MB_ICONERROR);
	//	RegCloseKey( key);
	//
	//	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, ".bdf", 0, KEY_SET_VALUE, &key);
	//	if(result == ERROR_SUCCESS)
	//		RegDeleteValue( key, "");
	//	else
	//		MessageBox(Loader, "RD birthday reminder", MB_ICONERROR);
	//	RegCloseKey( key);

	//now keys
	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, "birthdayfile\\shell\\open\\command", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
		RegDeleteKey( HKEY_CLASSES_ROOT, "birthdayfile\\shell\\open\\command");
	else
		error = true;
	RegCloseKey( key);

	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, "birthdayfile\\shell\\open", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
		RegDeleteKey( HKEY_CLASSES_ROOT, "birthdayfile\\shell\\open");
	else
		error = true;
	RegCloseKey( key);

	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, "birthdayfile\\shell", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
		RegDeleteKey( HKEY_CLASSES_ROOT, "birthdayfile\\shell");
	else
		error = true;
	RegCloseKey( key);

	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, "birthdayfile\\DefaultIcon", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
		RegDeleteKey( HKEY_CLASSES_ROOT, "birthdayfile\\DefaultIcon");
	else
		error = true;
	RegCloseKey( key);

	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, "birthdayfile", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
		RegDeleteKey( HKEY_CLASSES_ROOT, "birthdayfile");
	else
		error = true;
	RegCloseKey( key);

	result = RegOpenKeyEx(HKEY_CLASSES_ROOT, ".bdf", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
		RegDeleteKey( HKEY_CLASSES_ROOT, ".bdf");
	else
		error = true;
	RegCloseKey( key); 
	
	if(error)
		MessageBox(Loader, MSGBOXTITLE, MB_ICONERROR);
}

BOOL CAboutDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	return 0;
}

void CBirthdayDlg::RegFileExtCheck()
{
	CString AppName = __argv[0];
	AppName.MakeLower();

	CString KeyEntry;
	CKey key;
	key.m_hKey = HKEY_CLASSES_ROOT;
	key.Open(HKEY_CLASSES_ROOT,"birthdayfile\\shell\\open\\command");
	key.GetStringValue( KeyEntry, "");
	key.Close();
	KeyEntry.MakeLower();
	IsRegFileExt = false;
	if( AppName + " %1" == KeyEntry)
		IsRegFileExt = true;

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		bdr_registerfiletypes = IsRegFileExt;
	}


}

void CBirthdayDlg::OnButtonOptions() 
{
	OptionsDlg Options;

	Options.MagnetSize = MagnetSize;
	Options.IsOnTop = IsOnTop;
	Options.IsMagnetOn = IsMagnetOn;

	Options.bdr_alwaysontop = bdr_alwaysontop;
	Options.bdr_autorun = bdr_autorun;
	Options.bdr_regenabled = bdr_regenabled;
	Options.bdr_registerfiletypes = bdr_registerfiletypes;
	Options.bdr_savefile = bdr_savefile;
	Options.bdr_windowpos = bdr_windowpos;
	Options.bdr_closeonautorun = bdr_closeonautorun;
	
	Options.bOptRunonlyonce = bOptRunonlyonce;
	Options.strOptRunonlyonce = strOptRunonlyonce;
	Options.bOptOK2Tray = bOptOK2Tray;
	Options.bOptJustlook = bOptJustlook;


	Options.strHelpfile = strHelpfile;

	if( Options.DoModal() == IDOK)
	{
		//autostart
		if(!bdr_autorun && Options.bdr_autorun)
			CreateAutoStart();
		else if(bdr_autorun && !Options.bdr_autorun)
			DeleteAutoStart();
		bdr_autorun = Options.bdr_autorun;

		//alwaysontop
		if(	bdr_alwaysontop && !Options.bdr_alwaysontop)
			RegDeleteAlwaysOnTop();
		bdr_alwaysontop = Options.bdr_alwaysontop;
		
		//closeonautorun
		if(	!bdr_closeonautorun && Options.bdr_closeonautorun)
			RegCreateCloseonAutoRun();
		else if( bdr_closeonautorun && !Options.bdr_closeonautorun)
			RegDeleteCloseonAutoRun();
		bdr_closeonautorun = Options.bdr_closeonautorun;

		//Run only once
		strOptRunonlyonce = Options.strOptRunonlyonce;
		if( Options.bOptRunonlyonce && !bOptRunonlyonce)
			RegCreateBdrKey( "RunOnlyOnce", strOptRunonlyonce);
		else if( bOptRunonlyonce && !Options.bOptRunonlyonce)
			RegDeleteBdrKey( "RunOnlyOnce");
		bOptRunonlyonce = Options.bOptRunonlyonce;

		//OK2Tray
		if( Options.bOptOK2Tray && !bOptOK2Tray )
			RegCreateBdrKey( "OK2Tray", "1");
		else if( bOptOK2Tray && !Options.bOptOK2Tray)
			RegDeleteBdrKey( "OK2Tray");
		bOptOK2Tray = Options.bOptOK2Tray;

		//JustLook
		if( Options.bOptJustlook && !bOptJustlook )
			RegCreateBdrKey( "JustLook", "1");
		else if( bOptJustlook && !Options.bOptJustlook)
			RegDeleteBdrKey( "JustLook");
		bOptJustlook = Options.bOptJustlook;


		//regenabled
		if(	bdr_regenabled && !Options.bdr_regenabled)
		{
			RegDeleteRegEnabled();
			RegDeleteAlwaysOnTop();
			RegDeleteCloseonAutoRun();
			RegDeleteBdrKey( "RunOnlyOnce");
			RegDeleteBdrKey( "OK2Tray");
			RegDeleteBdrKey( "JustLook");

			DeleteAutoStart();
			RegDeleteSavefile();
			RegDeleteWindowPos();
			RegExtLinkDelete();
		}
		else
		{
			CheckRegistryFolders();
			RegAddRegEnabled();
		}
		bdr_regenabled = Options.bdr_regenabled;

		//savefile
		if( bdr_savefile && !Options.bdr_savefile)
		{
			RegDeleteSavefile();
		}
		bdr_savefile = Options.bdr_savefile;
		
		//windowpos
		if( bdr_windowpos && !Options.bdr_windowpos)
			RegDeleteWindowPos();
		bdr_windowpos = Options.bdr_windowpos;

		//link .bdf to bdr
		if(!bdr_registerfiletypes && Options.bdr_registerfiletypes)
			RegExtLinkAdd();
		else if(bdr_registerfiletypes && !Options.bdr_registerfiletypes)
			RegExtLinkDelete();
		bdr_registerfiletypes = Options.bdr_registerfiletypes;
	}
}


void CBirthdayDlg::LoadRegistries()
{
	CString KeyEntry = "";
	CKey key;

	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER,"Control Panel\\Desktop");
	key.GetStringValue( KeyEntry, "DragFullWindows");
	key.Close();
	if(KeyEntry == "0")
		ChangeMagnetBorder();
		
	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER,"SOFTWARE\\RealDreams\\BirthdayReminder");
	key.GetStringValue( KeyEntry, "RegAllowed");
	if(KeyEntry == "1")
	{
		bdr_regenabled = true;

		KeyEntry = "";
		key.GetStringValue( KeyEntry, "Magnetborder");
		if(KeyEntry != "")
		{
			bdr_alwaysontop = true;
			if( (!IsMagnetOn && KeyEntry == "1") ||	(IsMagnetOn && KeyEntry != "1") )
				ChangeMagnetBorder();
			key.GetStringValue( KeyEntry, "AlwaysOnTop");
			if( (!IsOnTop && KeyEntry == "1") || (IsOnTop && KeyEntry != "1") )
				ChangeOnTop();

		}
		else
			bdr_alwaysontop = false;

		//Birthdayfile
		KeyEntry = "";
		key.GetStringValue( KeyEntry, "BirthdayFile");
		if(KeyEntry != "")
			bdr_savefile = true;
		else
			bdr_savefile = false;

		//CloseonAutoRun
		KeyEntry = "";
		key.GetStringValue( KeyEntry, "CloseonAutoRun");
		if(KeyEntry != "")
			bdr_closeonautorun = true;
		else
			bdr_closeonautorun = false;

		//RunOnlyOnce
		KeyEntry = "";
		if( key.GetStringValue( KeyEntry, "RunOnlyOnce"))
		{
			bOptRunonlyonce  = true;
			strOptRunonlyonce = KeyEntry;
		}
		else
		{
			bOptRunonlyonce = false;
			strOptRunonlyonce = "";
		}

		//OK2Tray
		KeyEntry = "";
		if( key.GetStringValue( KeyEntry, "OK2Tray"))
		{
			bOptOK2Tray = true;
		}
		else
		{
			bOptOK2Tray = false;
		}

		//JustLook
		KeyEntry = "";
		if( key.GetStringValue( KeyEntry, "JustLook"))
		{
			bOptJustlook = true;
		}
		else
		{
			bOptJustlook = false;
		}

		//Windowpos
		KeyEntry = "";
		key.GetStringValue( KeyEntry, "WindowPosX");
		if(KeyEntry != "")
		{
			bdr_windowpos = true;
			RECT pos;
			int xpos, ypos;
			GetWindowRect( &pos);
			xpos = pos.left;
			ypos = pos.top;

			
			SystemParametersInfo(SPI_GETWORKAREA,0,ScreenSize,0);
			if(atoi(KeyEntry) < ScreenSize.right - ScreenSize.left && atoi(KeyEntry) >= 0)
				xpos = atoi(KeyEntry);
			key.GetStringValue( KeyEntry, "WindowPosY");
			if(KeyEntry != "" && atoi(KeyEntry) < ScreenSize.bottom - ScreenSize.top && atoi(KeyEntry) >= 0)
				ypos = atoi(KeyEntry);
			SetWindowPos(&wndNoTopMost, xpos, ypos, 0, 0, SWP_NOSIZE);
			ChangeOnTop();
			ChangeOnTop();
		}
		else
			bdr_windowpos = false;



		//List Headers
		//They are loaded in CreateListHeaders()
		strListHeaders	= "";
		key.GetStringValue( strListHeaders, "ListHeaders");


		//Close the reg key
		key.Close();

		CheckAutoStart();
		RegFileExtCheck();
	}
	else
	{
		bdr_closeonautorun = false;
		bdr_regenabled = false;
		bdr_alwaysontop = false;
		bdr_autorun = false;
		bdr_registerfiletypes = false;
		bdr_windowpos = false;
		bOptRunonlyonce = false;
		strOptRunonlyonce = "";
		bOptOK2Tray = false;

		key.Close();
	}

}

/////////////////////////////////////////////////////////////////////////////
// Autostart link
void CBirthdayDlg::CreateAutoStart()
{
	CString AppName = __argv[0];
	AppName.MakeLower();

   	LONG		lRv;
	HKEY		hKey;
	lRv = RegCreateKeyEx(HKEY_CURRENT_USER,TEXT("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run"),0,NULL,REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,NULL,&hKey,NULL);
	RegCloseKey(hKey);

	CKey key;
	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER,"Software\\Microsoft\\Windows\\CurrentVersion\\Run");
	key.SetStringValue("\"" + AppName + "\" /autostart", "RDBirthdayReminder");
	key.Close();
}

void CBirthdayDlg::RegCreateCloseonAutoRun()
{
	CKey key;
	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER,"SOFTWARE\\RealDreams\\BirthdayReminder");
	key.SetStringValue("1", "CloseonAutoRun");
	key.Close();
}

void CBirthdayDlg::DeleteAutoStart()
{

	HKEY key;
	long result = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\Run", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
		RegDeleteValue( key, "RDBirthdayReminder");
	else
	{
		Loader.LoadString(IDS_REG_AUTOSTART);
		MessageBox(Loader, MSGBOXTITLE, MB_ICONERROR);
	}
	RegCloseKey( key);
}

void CBirthdayDlg::CheckAutoStart()
{
	CString AppName = __argv[0];
	AppName.MakeLower();

	CString KeyEntry;
	CKey key;
	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER,"Software\\Microsoft\\Windows\\CurrentVersion\\Run");
	key.GetStringValue( KeyEntry, "RDBirthdayReminder");
	KeyEntry.MakeLower();
	if(KeyEntry == "\"" + AppName + "\" /autostart")
		bdr_autorun = true;
	else
		bdr_autorun = false;
}

void CBirthdayDlg::RegDeleteAlwaysOnTop()
{
	HKEY key;
	long result = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\RealDreams\\BirthdayReminder", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
	{
		RegDeleteValue( key, "AlwaysOnTop");
		RegDeleteValue( key, "Magnetborder");
	}
	else
	{
		Loader.LoadString(IDS_REG_MAGNETBORDER);
		MessageBox(Loader, MSGBOXTITLE, MB_ICONERROR);
	}
	RegCloseKey( key);
}

void CBirthdayDlg::RegDeleteCloseonAutoRun()
{
	HKEY key;
	long result = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\RealDreams\\BirthdayReminder", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
	{
		RegDeleteValue( key, "CloseonAutoRun");
	}
	else
	{
		Loader.LoadString(IDS_REG_CLOSEONAUTORUN);
		MessageBox(Loader, MSGBOXTITLE, MB_ICONERROR);
	}
	RegCloseKey( key);
}

void CBirthdayDlg::RegDeleteRegEnabled()
{
	HKEY key;
	long result = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\RealDreams\\BirthdayReminder", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
		RegDeleteValue( key, "RegAllowed");
	else	  
	{
		Loader.LoadString(IDS_REG_REGENABLED);
		MessageBox(Loader, MSGBOXTITLE, MB_ICONERROR);
	}
	RegCloseKey( key);

}

void CBirthdayDlg::RegDeleteWindowPos()
{
	HKEY key;
	long result = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\RealDreams\\BirthdayReminder", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
	{
		RegDeleteValue( key, "WindowPosX");
		RegDeleteValue( key, "WindowPosY");
	}
	else
	{
		Loader.LoadString(IDS_REG_WINDOWPOS);
		MessageBox(Loader, MSGBOXTITLE, MB_ICONERROR);
	}
	RegCloseKey( key);

}

void CBirthdayDlg::RegDeleteSavefile()
{
	HKEY key;
	long result = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\RealDreams\\BirthdayReminder", 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
	{
		RegDeleteValue( key, "BirthdayFile");
	}
	else
	{
		Loader.LoadString(IDS_REG_SAVEFILE);
		MessageBox(Loader, MSGBOXTITLE, MB_ICONERROR);
	}
	RegCloseKey( key);

}


void CBirthdayDlg::RegAddRegEnabled()
{
	CKey key;
	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER,"SOFTWARE\\RealDreams\\BirthdayReminder");
	key.SetStringValue("1", "RegAllowed");
	key.Close();

}

void CBirthdayDlg::RegSaveListHeaders()
{
	CHeaderCtrl *hctrlHeader		= m_list_events.GetHeaderCtrl();
	int nColumns		= hctrlHeader->GetItemCount();
	CString strHeader	= "";
	CString strTemp		= "";
	int nColWidth		= 0;

	for( int nCol = 0; nCol < nColumns; nCol++) {
		nColWidth	= m_list_events.GetColumnWidth( nCol);
		strTemp.Format( "%d", nColWidth);
		strHeader += strTemp + "|";
	}

	CKey key;
	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER,"SOFTWARE\\RealDreams\\BirthdayReminder");
	key.SetStringValue(strHeader , "ListHeaders");
	key.Close();
}


BOOL CBirthdayDlg::DestroyWindow() 
{

	if(bdr_regenabled)
	{
		RegSaveAll();
	}

	return CDialog::DestroyWindow();
}

//Called when closing bdr

void CBirthdayDlg::RegSaveAll()
{
	CKey key;
	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER,"SOFTWARE\\RealDreams\\BirthdayReminder");
	if(bdr_alwaysontop)
	{
		if(IsMagnetOn)
			Loader = "1";
		else
			Loader = "0";
		key.SetStringValue(Loader, "Magnetborder");
		if(IsOnTop)
			Loader = "1";
		else
			Loader = "0";
		key.SetStringValue(Loader, "AlwaysOnTop");
	}
	if(bdr_windowpos)
	{
		GetWindowRect(WindowPos);
		
		ltoa(WindowPos.left, (char*)(const char*)Loader, 10);
		key.SetStringValue(Loader, "WindowPosX");
		ltoa(WindowPos.top, (char*)(const char*)Loader, 10);
		key.SetStringValue(Loader, "WindowPosY");
	}
	key.Close();

	if( bOptRunonlyonce)
		RegCreateBdrKey( "RunOnlyOnce", "");

	RegSaveListHeaders();
}


void CBirthdayDlg::OnHelp() 
{
	ShowHelpDialog();
}


//bool CBirthdayDlg::DisplayDate()
//-----------------
//displays the current date	in the title bar
bool CBirthdayDlg::DisplayDate()
{
	COleDateTime tmTime = COleDateTime::GetCurrentTime();

	strDisplaydate			= tmTime.Format( "%d.%m.%Y");	//used internally
	CString strTimestring = tmTime.Format( "%#x");
	//strTimestring	= sfxFormatLongDate( tmTime);	//The timestring for the window
	
	Loader.LoadString( IDS_DLG_MAINWINDOW);
	CString strDummy = "";
	strDummy.Format( Loader, strTimestring);
	CBirthdayDlg::SetWindowText( strDummy);

	return true;
}

CString CBirthdayDlg::sfxFormatLongDate(COleDateTime dt)
{																	   TCHAR sz[255];

	SYSTEMTIME st;

	st.wYear = (WORD)dt.GetYear();
	st.wMonth = (WORD)dt.GetMonth();
	st.wDayOfWeek = 0;
	st.wDay = (WORD)dt.GetDay();
	st.wHour = 0;
	st.wMinute = 0;
	st.wSecond = 0;
	st.wMilliseconds = 0;

	GetDateFormat(LOCALE_USER_DEFAULT,	// locale for which date is to be formatted
		DATE_LONGDATE,					// flags specifying function options
		&st,							// date to be formatted
		NULL,							// date format string
		sz,								// buffer for storing formatted string
		254								// size of buffer
	);


return CString(sz);
}

//bool CBirthdayDlg::ShowHelpDialog(LPCSTR pszFile = "", UINT uCommand = HH_DISPLAY_TOPIC)
//-----------------
//Shows the help window
bool CBirthdayDlg::ShowHelpDialog(CString pszFile, UINT uCommand)
{
	CFileStatus FileStatus;

	//if file exists, try to show dialog
	if( !bJustlook && CFile::GetStatus( strHelpfile, FileStatus) != 0)
	{
		
		HWND hwnd = 0;
		if( pszFile == "")
		{
			HWND hwnd = HtmlHelp( m_hWnd, strHelpfile, uCommand, NULL);
		}
		else
		{
			Loader = strHelpfile + "::/" + pszFile;			
			HWND hwnd = HtmlHelp( m_hWnd, Loader, uCommand, NULL);
			//HWND hwnd = HtmlHelp( m_hWnd, "e:\\c++\\programme\\birthday\\Debug\\birthday.chm::001 - welcome.htm>Main", uCommand, NULL);
		}

/*		if( hwnd == NULL)
		{
			MessageBox( "Error while creating the help window.", MSGBOXTITLE, MB_ICONERROR);
			return false;
		}
*/	}
	//No help file? Show about dialog
	else
	{
		CAboutDlg dlgAbout;
		dlgAbout.bJustlook = bJustlook;
		dlgAbout.DoModal();
	}

	return true;
}


bool CBirthdayDlg::RegCreateBdrKey(CString strKey, CString strValue)
{
	CString strKeyLocation = "SOFTWARE\\RealDreams\\BirthdayReminder";
	CString strKeyKey = strKey;

	if( strKey == "RunOnlyOnce")
	{
		CTime tmTime = CTime::GetCurrentTime();
		strValue = tmTime.Format( "%d.%m.%Y");
	}
	
	

	CKey key;
	key.m_hKey = HKEY_CURRENT_USER;
	key.Open(HKEY_CURRENT_USER, strKeyLocation);
	key.SetStringValue( strValue, strKeyKey);
	key.Close();

	return true;
}


bool CBirthdayDlg::RegDeleteBdrKey(CString strKey)
{
	CString strKeyLocation = "SOFTWARE\\RealDreams\\BirthdayReminder";
	CString strKeyKey = strKey;


	HKEY key;
	long result = RegOpenKeyEx(HKEY_CURRENT_USER, strKeyLocation, 0, KEY_SET_VALUE, &key);
	if(result == ERROR_SUCCESS)
	{
		RegDeleteValue( key, strKeyKey);
	}
	else
	{
		Loader.LoadString(IDS_REG_CANTDELETE);
		CString strDummy;
		strDummy.Format( Loader, strKeyKey);
		MessageBox(Loader, MSGBOXTITLE, MB_ICONERROR);
	}
	RegCloseKey( key);


	if( result == ERROR_SUCCESS)
		return true;
	else
		return false;
}

void CBirthdayDlg::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent == 2000)
	{
		CTime tmTime = CTime::GetCurrentTime();
		CString strCurrentdate = tmTime.Format( "%d.%m.%Y");
		if( strCurrentdate != strDisplaydate)
		{
			ActBirthFile.CalcTimeDiff();
			ListOut();
			DisplayDate();
			strDisplaydate = strCurrentdate;

			//show only if there are events in the box
			if( m_list_events.GetItemCount() > 0)
				WindowActivate();
		}
		//ReRun the timer
		SetTimer( 2000, ITIMER, NULL);
	}

	CDialog::OnTimer(nIDEvent);
}

void CBirthdayDlg::OnTimeChange() 
{
	CDialog::OnTimeChange();
	
	OnTimer( 2000);	
}





 /****************************************************************************
 *                                                                          
 *  FUNCTION   : TrayMessage (HWND hDlg, DWORD dwMessage, UINT uID, 
 *                            HICON hIcon, PSTR pszTip )
 *                                                                          
 *  PURPOSE    : Creates, Modifies or deletes the tray icon 
 *               If pszTip is not null, it uses that for the tip
 *               otherwise it sets a default tip
 *                                                                          
 \****************************************************************************/

BOOL CBirthdayDlg::TrayMessage( HWND hDlg, DWORD dwMessage, UINT uID, HICON hIcon, PSTR pszTip )
{
    BOOL res;
    NOTIFYICONDATA tnd;

    //
    // Get the Tray Icon
    //

    
	hIcon = (HICON)LoadImage( AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON,
			     16, 16, 0);
    
    tnd.cbSize		= sizeof(NOTIFYICONDATA);
    tnd.hWnd		= hDlg;
    tnd.uID			= uID;
    tnd.uFlags		= NIF_MESSAGE|NIF_ICON|NIF_TIP;
    tnd.uCallbackMessage	= MYWM_NOTIFYICON;
    tnd.hIcon		= hIcon;

	
    //
    // If there is a specific tip, set it
    // otherwise use SetDisp as the default
    //

    if (pszTip)
    {
		lstrcpyn(tnd.szTip, pszTip, sizeof(tnd.szTip));
    }
    else
    {
		lstrcpyn(tnd.szTip, "SetDisp", sizeof("SetDisp"));;
    }

	
    //
    //	Use the Shell_NotifyIcon API to setup the tray icon
    //

    res = Shell_NotifyIcon(dwMessage, &tnd);

    if( hIcon)
    {
		DestroyIcon(hIcon);
    }


    return res;

}


 /****************************************************************************
 *                                                                          
 *  FUNCTION   : NotifyDelete (HWND hDlg, UINT uIndex)
 *                                                                          
 *  PURPOSE    : Deletes a tray icon based on the uIndex .
 *               In this SetDisp sample, it is only used for a single icon
 *                                                                          
 \****************************************************************************/

void CBirthdayDlg::NotifyDelete( HWND hDlg, UINT uIndex)

{

    TrayMessage(hDlg, NIM_DELETE, uIndex, NULL, NULL);

}


 /****************************************************************************
 *                                                                          
 *  FUNCTION   : NotifyAdd (HWND hDlg, UINT uIndex)
 *                                                                          
 *  PURPOSE    : Creates tray icons based on the uIndex .
 *               In this SetDisp sample, it is only used for a single icon
 *                                                                          
 \****************************************************************************/

void CBirthdayDlg::NotifyAdd( HWND hDlg, UINT uIndex, HICON hIcon, PSTR pszTip)

{

	TrayMessage(hDlg, NIM_ADD, uIndex, hIcon, pszTip);
    RegisterWindowMessage("TaskbarCreated");

}


void CBirthdayDlg::OnOK() 
{
	if( bOptOK2Tray)
	{
		Window2Tray();
	}
	else
	{
		CDialog::OnOK();
	}
}

LRESULT CBirthdayDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if( message == MYWM_NOTIFYICON)
    {
		switch (lParam)
		{
		    case WM_LBUTTONUP:
				WindowActivate();
				break;
		}
	}
	
	return CDialog::WindowProc(message, wParam, lParam);
}

//used when showing from tray
void CBirthdayDlg::WindowActivate()
{
	NotifyDelete( m_hWnd, 1);
	ShowWindow( SW_RESTORE);
	SetForegroundWindow();
}

//send it to tray
void CBirthdayDlg::Window2Tray()
{
	NotifyAdd( m_hWnd, 1, NULL, MSGBOXTITLE);
	ShowWindow( SW_HIDE);
}

void CBirthdayDlg::ActivateJustlook()
{
	bJustlook = true;

	m_button_edit.EnableWindow		( false);
	m_button_options.EnableWindow	( false);
	m_button_openother.EnableWindow	( false);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->EnableMenuItem( IDM_MNU_ONTOP,MF_BYCOMMAND | MF_GRAYED);
		pSysMenu->EnableMenuItem( IDM_MNU_MAGNET,MF_BYCOMMAND | MF_GRAYED);
	}
}

void CBirthdayDlg::OnDblclkListEvents(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if( !bJustlook)
	{
		POSITION pPos = m_list_events.GetFirstSelectedItemPosition();
		//must be one selected
		if( pPos != NULL)
		{
			//get name
			int nItem = m_list_events.GetNextSelectedItem( pPos);
			CString strName = m_list_events.GetItemText( nItem, 4);
			ShellExecute( 0, NULL, "mailto:" + strName, NULL, NULL, SW_SHOW);
		}//be sure that there is an item selected
	}//no justlook
	
	*pResult = 0;
}




void CBirthdayDlg::OnDropFiles(HDROP dropInfo)
{
	// Get the number of pathnames that have been dropped
	WORD wNumFilesDropped = DragQueryFile(dropInfo, -1, NULL, 0);

	CString csFirstFile = _T("");

	// there may be many, but we'll only use the first
	if (wNumFilesDropped > 0)
	{
		// Get the number of bytes required by the file's full pathname
		WORD wPathnameSize = DragQueryFile(dropInfo, 0, NULL, 0);

		// Allocate memory to contain full pathname & zero byte
		wPathnameSize+=1;

		char * pFile = new TCHAR[wPathnameSize];
		if (pFile == NULL)
		{
			ASSERT(0);
			DragFinish(dropInfo);
			return;
		}

		// Copy the pathname into the buffer
		DragQueryFile(dropInfo, 0, pFile, wPathnameSize);

		csFirstFile = pFile;

		// clean up
		delete [] pFile; 
	}

	// Free the memory block containing the dropped-file information
	DragFinish(dropInfo);

	// if this was a shortcut, we need to expand it to the target path
	CString csExpandedFile = ExpandShortcut(csFirstFile);

	// if that worked, we should have a real file name
	if (!csExpandedFile.IsEmpty()) 
	{
		csFirstFile = csExpandedFile;
	}

	if (!csFirstFile.IsEmpty())
	{
		struct _stat buf;
	
		// get some info about that file
		int result = _stat( csFirstFile, &buf );
		if( result == 0 ) 
		{
			// verify that we have a dir (if we want dirs)
			if ((buf.st_mode & _S_IFDIR) == _S_IFDIR) 
			{

			} 
			// verify that we have a file (if we want files)
			else if ((buf.st_mode & _S_IFREG) == _S_IFREG) 
			{
				if( csFirstFile.Right( 4) == ".bdf" || csFirstFile.Right( 4) == ".xml")
					OpenFile( csFirstFile);
				else
				{
					Loader.LoadString( IDS_MSG_NOBDFFILE);
					MessageBox( Loader, MSGBOXTITLE, MB_ICONSTOP);
				}
			}
		}
	}
}//void CBirthdayDlg::OnDropFiles(HDROP dropInfo)

//////////////////////////////////////////////////////////////////
//	use IShellLink to expand the shortcut
//	returns the expanded file, or "" on error
//
//	original code was part of CShortcut 
//	1996 by Rob Warner
//	rhwarner@southeast.net
//	http://users.southeast.net/~rhwarner

CString CBirthdayDlg::ExpandShortcut(CString &inFile)
{
	CString outFile;

    // Make sure we have a path
    ASSERT(inFile != _T(""));

    IShellLink* psl;
    HRESULT hres;
    LPTSTR lpsz = inFile.GetBuffer(MAX_PATH);

    // Create instance for shell link
    hres = ::CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*) &psl);

    if (SUCCEEDED(hres))
    {
        // Get a pointer to the persist file interface
        IPersistFile* ppf;

        hres = psl->QueryInterface(IID_IPersistFile, (LPVOID*) &ppf);
        if (SUCCEEDED(hres))
        {
            // Make sure it's ANSI
            WORD wsz[MAX_PATH];
            ::MultiByteToWideChar(CP_ACP, 0, lpsz, -1, wsz, MAX_PATH);

            // Load shortcut
            hres = ppf->Load(wsz, STGM_READ);

            if (SUCCEEDED(hres)) 
			{
				WIN32_FIND_DATA wfd;

				// find the path from that
				HRESULT hres = psl->GetPath(outFile.GetBuffer(MAX_PATH), 
								MAX_PATH,
								&wfd, 
								SLGP_UNCPRIORITY);

				outFile.ReleaseBuffer();
            }

            ppf->Release();
        }

        psl->Release();
    }

	inFile.ReleaseBuffer();

	// if this fails, outFile == ""
    return outFile;
}//CString CBirthdayDlg::ExpandShortcut(CString &inFile)



//open any file
void CBirthdayDlg::OpenFile(CString strFile)
{
	ActBirthFile.InitVariables();
	ActBirthFile.FileName = strFile;

	//check if file exists, if not - ask for create new one
	CFileStatus FileStatus;
	int exist = CFile::GetStatus( ActBirthFile.FileName, FileStatus);
	if( exist == 0)
	{
/*			Loader.LoadString(IDS_MSG_CREATENEWFILE);
		Loader = Loader + "\nFile:\n" + ActBirthFile.FileName;
		if( MessageBox( Loader, MSGBOXTITLE, MB_YESNO + MB_ICONQUESTION) == IDYES)
		{
*/				CFile newfile;
			CFileException fexFileException;
			if( !newfile.Open( ActBirthFile.FileName, CFile::modeCreate | CFile::modeNoTruncate, &fexFileException))
			{
				CString strErrText;
				strErrText.LoadString( IDS_PARSE_FILEOPEN_ERROR_TEXT);

				strErrText.Format( "%d", fexFileException.m_cause);
				MessageBox( strErrText, MSGBOXTITLE, 0 + MB_ICONSTOP );
				
			}
			newfile.Close();
//			}
	}


	//ask if this file should be opened always
	exist = CFile::GetStatus( ActBirthFile.FileName, FileStatus);
	if( exist != 0)
	{
		m_button_edit.EnableWindow( true);
		Loader.LoadString(IDS_FILEASSTANDARD);
		if(MessageBox(Loader, MSGBOXTITLE, MB_YESNO + MB_ICONQUESTION) == IDYES)
		{
				CheckRegistryFolders();
				CString KeyEntry;
				CKey key;
				key.m_hKey = HKEY_CURRENT_USER;
				key.Open(HKEY_CURRENT_USER,"Software\\RealDreams\\BirthdayReminder");
				key.SetStringValue( strFile, "BirthdayFile");
				key.SetStringValue("1", "RegAllowed");
				key.Close();
				bdr_savefile = true;
				bdr_regenabled = true;
		}

		ActBirthFile.FileNameOld = ActBirthFile.FileName;
		ActBirthFile.FileName = strFile;
		ActBirthFile.StartParsing(&ActBirthFile, false);
		ListOut();

		if( ActBirthFile.CountPersons == -1)
		{
			bAutoEdit = true;
			OnButtonEdit();
		}

	}//exists file?

}//void CBirthdayDlg::OpenFile(CString strFile)


